#coding: latin-1
#Ab Python2.3 ist die uncodierte Verwendung von Umlauten deprecated.
import md5
import string
import os
import cPickle
import sys

# Konstanten:
add = "4g5t"
KATEGORIEN = ("Datenbank","Benutzer","Passwort","EMailAdresse","Rechte","EMailErlaubt")
EINLESEN = "csv2checkin.txt"
AUSGABE = "checkin"
UPDATE = 0
if os.path.exists(AUSGABE):
    UPDATE = 1

def csvdatei_einlesen(datei,trenner):
    """Spaltenberschriften als erste Zeile werden nicht gesondert behandelt!
    Rckgabeformat: Liste von Liste."""
    trenner_dict = {""" """: "Leerzeichen","""\t""": "Tabulator",""",""": "Komma",""";""": "Semikolon"}
    trenner_bezeichnung = trenner_dict[trenner]
    del trenner_dict[trenner]
    # *** TODO: Probleme bei leeren Datenfeldern? (reprsentiert z.B. von zwei aufeinanderfolgenden Tabs)
    rueck_matrix = []
    try:
        f = open(datei,'r')
    except:
        print "Wo ist Datei %s?" % datei
        return 0
    inhalt = f.readlines()
    test_text = string.join(inhalt,"")
    for e in trenner_dict.keys():
        zahl = 0
        for i in test_text:
            if i == e:
                zahl += 1
        if zahl > (len(KATEGORIEN)-2) * len(inhalt):
            print "Vermutlich haben Sie die Datei \"%s\" versehentlich" % EINLESEN
            print "mit dem falschen Feldtrenner \"%s\" anstelle von \"%s\" " % (trenner_dict[e],trenner_bezeichnung)
            print "gespeichert (z.B. mit einer Tabellenkalkulation)."
            raw_input("Eingabetaste zum Beenden: " )
            sys.exit()
    kategorien = string.split(inhalt[0],trenner)
    laenge = len(kategorien)
    for i in inhalt:
        temp = string.split(i,trenner)
        if len(temp) != laenge:
            print "Importierte Tabelle %s ist inkonsistent bei Element %s." %(datei,temp)
            raw_input("Eingabetaste zum Beenden: ")
            sys.exit()
        else:
            for i in range(len(temp)):
                temp[i] = string.strip(temp[i]) # angehngte Return weg usw.
                temp[i] = temp[i].replace('\"','') # sog. "Feldtrenner" weg.
                temp[i] = temp[i].replace("\'","")
            rueck_matrix.append(temp)        
    f.close()
    return rueck_matrix

def alsDictionary(spalten,array):
    # macht aus einem Array von Array ein
    # Array von Dictionaries, jeweils mit den
    # Namen aus "spalten" als Schlssel
    temparray = []
    for i in array:
        tempdict = {}
        for j in range(len(spalten)):
            tempdict[spalten[j]] = i[j]
        temparray.append(tempdict)
    return temparray

def doppelEintrag(dictarray,kategorie="Rechte",wert="a",testfeld="Datenbank",name="Benutzer"):
    test = {}
    temparray = []
    admin = []
    for i in dictarray:
        if i[kategorie] == wert:
            if test.has_key(i[testfeld]):
                test[i[testfeld]] += 1
                temparray.append(i)
            else:
                test[i[testfeld]] = 1
            if i[name] not in admin:
                admin.append(i[name])
    for i in test.keys():
        if (test[i] > 1) or len(admin) > 1:
            return 1,temparray,admin
    return 0,temparray,admin

gesamt = {}
# Rechte: a (Admin - nur einmal erlaubt pro Bezirksreiter-Installation!), w (Schreiben), r (Lesen) 
# EMailErlaubt: mail, nomail
matrix = csvdatei_einlesen(datei=EINLESEN,trenner=";")
for i in range(len(KATEGORIEN)):
    if matrix[0][i] != KATEGORIEN[i]:
        print "Nichtuebereinstimmung von Kategorie %s <=> %s !" % (matrix[0][i],KATEGORIEN[i])
        raw_input("Eingabetaste zum Beenden: ")
        sys.exit()
dictarray = alsDictionary(KATEGORIEN,matrix[1:])

doppel = doppelEintrag(dictarray)
if doppel[0]:
    for i in doppel[1]:
        print "%s\n" % i
    print "Admins: %s" % string.join(doppel[2])
    print "Sie duerfen nur einen Administrator\n(Rechte = a) eintragen!"
    raw_input("Eingabetaste zum Beenden: ")
    sys.exit()

for d in dictarray:
    #print d
    code = md5.new(d["Benutzer"]+d["Passwort"]+add+d["Datenbank"]).hexdigest()
    eintrag = {d["Benutzer"]: (code,d["EMailAdresse"],d["Rechte"],d["EMailErlaubt"])}
    #print "Eintrag", eintrag
    if gesamt.has_key(d["Datenbank"]):
        gesamt[d["Datenbank"]][d["Benutzer"]] = eintrag[d["Benutzer"]]
    else:
        gesamt[d["Datenbank"]] = eintrag

print gesamt
if UPDATE:
    os.rename(AUSGABE,AUSGABE+"_alt")
    print "Die alte Passwort-Datei \"%s\" wurde als \"%s\" gesichert!" % (AUSGABE,AUSGABE+"_alt")

datei = open(AUSGABE,"wb")
cPickle.dump(gesamt,datei)
datei.close()
print "Die neue Passwort-Datei wurde als \"%s\" gespeichert!" % AUSGABE
raw_input("Eingabetaste zum Beenden: ")
