#coding: latin-1
#Ab Python2.3 ist die uncodierte Verwendung von Umlauten deprecated.
import normalDate
import datumutilities
import textutilities
import sys
import re
import os
import string
import verwaltungmysql
import sortieren
import types
import pickle
import cPickle
import glob

heute = datumutilities.Datum()

class StateMain:
    """Dieses Klasse ist ein einfaches State-Recovery-Tool. Der jew. User der Datenbank
    wird z.B mit einem HTTP-Cookie identifiziert, das dann als "user" bergeben wird."""

    def __init__(self,user):
        self.user = user
        self.userDir = "UserDir_%s" % self.user
        if not os.path.exists(self.userDir):
            os.mkdir(self.userDir)
            try:
                os.chmod(self.userDir,0766)
            except:
                pass

    def variableSetzen(self,variable,wert):
        try:
            datei = open("%s/%s" % (self.userDir,variable),"wb")
            # Binrdatei: fr Windows
            cPickle.dump(wert,datei)
            datei.close()
        except:
            raise(IOError)

    def variableHolen(self,variable):
        datei = open("%s/%s" % (self.userDir,variable),"rb")
        return cPickle.load(datei)

    def dicteintragPruefen(self,variable,key):
        """Prft bei der Variable (wenn ein dict) nach einem key."""
        temp = self.variableHolen(variable)
        print temp
        if temp.has_key(key):
            return 1
        else:
            return 0

    def dicteintragSetzen(self,variable,key,wert):
        temp = self.variableHolen(variable)
        temp[key] = wert
        self.variableSetzen(variable,temp)

    def dicteintragLoeschen(self,variable,key):
        temp = self.variableHolen(variable)
        del temp[key]
        self.variableSetzen(variable,temp)
    

class State(StateMain):
    """Diese Klasse darf auf alles zugreifen, nur nicht auf die Systemvariablen."""
    def __init__(self,user):
        if user == "SystemVariablen":
            raise IOError("Der Client darf nicht auf Systemvariablen zugreifen.")
        else:
            StateMain.__init__(self,user)
        

class StateSystem(StateMain):
    """Zum Zugriff auf Systemvariablen u.a."""

    def __init__(self):
        StateMain.__init__(self,"SystemVariablen")
        # Initialisierung der userliste aller eingeloggten User:
        try:
            self.variableHolen("userdict")
        except:
            self.variableSetzen("userdict",{})
    
    def userDirsAufraeumen(self):
        """Beseitigt alle UserDir... Verzeichnisse rekursiv
        aus dem aktuellen Verzeichnis. Bei Starten von cgiserver_verwaltung.py
        benutzt. vgl. auch Programming Python S.233.
        Geht auch mit shutils, s. install.py"""
        alleDirs = glob.glob("UserDir*")
        for d in alleDirs:
            self.rmall(d)
            # Verzeichnis leeren
            os.rmdir(d)
            # und dann lschen

    def rmall(self,dir):
        alleNamen = os.listdir(dir)
        for name in alleNamen:
            pfad = os.path.join(dir,name)
            if not os.path.isdir(pfad):
                os.remove(pfad)
            else:
                # rekursiver Aufruf!
                rmall(pfad)
    
    
            

 
   

