#coding: latin-1
#Ab Python2.3 ist die uncodierte Verwendung von Umlauten deprecated.
import normalDate
import datumutilities
import textutilities
import sys
import re
import os
import string
import verwaltungmysql
import sortieren
import types
import pickle
import cPickle

heute = datumutilities.Datum()
primaerkartei = 'user'

class State(verwaltungmysql.MySQLZugriff):
    """Diese Klasse ist ein einfaches State-Recovery-Tool. Der jew. User der Datenbank
    wird z.B mit einem HTTP-Cookie identifiziert, das dann als "user" bergeben wird.
    In der Tabelle "State" werden als String gepickelte Objekte usw. abgelegt.
    Auf diese Weise bentigt man keinen Zugriff auf das Dateisystem des Servers.
    *** Achtung: beim Zugriff auf die Datenbank darf der MySQL-"insert"-Befehl
    (s.Superklasse) nicht mit einfachen Anfhrungszeichen die values einsetzen!
    Nur doppelte verwenden. Ein Bug?"""

    def __init__(self,MysqlDatenbank,user,datenbank,tabelle="state"):
        verwaltungmysql.MySQLZugriff.__init__(self,MysqlDatenbank,datenbank,tabelle)
        self.user = self.neuerUser(user)
        # os.mkdir("UserDir_%s" % self.user)

    def primaerschluessel(self):
        return primaerkartei

    def neuerEintrag(self,neudict,primaerdummy=primaerkartei,schluesselwert=None):
        """berschreibt die Funktion in der bergeordneten Klasse MySQLZugriff"""
        pass

    def neuerUser(self,user):
        temp = self.schluesselSuchen(user)
        if temp == [()]:
            # user noch nicht vorhanden?
            tempdict = self.holeLeerenEintrag()
            tempdict.update({primaerkartei: user})
            # print self.neuerEintragDirekt(tempdict)
        return user

    def userLoeschen(self):
        return verwaltungmysql.MySQLZugriff.eintragLoeschen(self,primaerkartei,self.user)

    def variableSetzen(self,variable,wert):        
        neuwert = cPickle.dumps(wert)
        # print "wert",wert
        # neuwert = wert.replace("\\","EScape")
        # neuwert = wert
        self.eintragAendern({variable: neuwert},primaerkartei,self.user)

    def variableHolen(self,variable):
        temp = self.schluesselSuchen(self.user)[0][variable]
        # temp = temp.replace("EScape","\\")
        temp = cPickle.loads(temp)
        return temp

    def stringSetzen(self,variable,wert):
        self.eintragAendern({variable: wert},primaerkartei,self.user)

    def stringHolen(self,variable):
        temp = self.schluesselSuchen(self.user)
        return temp[0][variable]
        

    def eintragLoeschen(self,primaerdummy=primaerkartei,schluesselwert=None):
        """berschreibt die gleichnamige Funktion aus MySQLZugriff"""
        pass 

    def schluesselSuchen(self,schluessel):
        return self.eintragSuchfunktion({primaerkartei: schluessel})
 
   

