#coding: latin-1
#Ab Python2.3 ist die uncodierte Verwendung von Umlauten deprecated.
import streamredirect
import MySQLdb
import MySQLdb.converters
import sys
import gemeindeverwaltung
import htmlutilities
import string
import datumutilities
import cgi
import urllib
import Cookie
import os
import gemeindekarteiweb
import baukontoweb
import optionenweb
import optionen
import re
import verwaltungMainUtilities
import statemysql
import state
import time
import kontenplan
import kontenplanweb
import update
# import gesangbuchweb
import abkuerzungenweb
import verwaltungMainServer
import verwaltungMainObjekt
import textutilities


class verwaltungMainFunktion(verwaltungMainObjekt.verwaltungMainObjekt):
    """Die Objektklasse fr die FiBu (Nicht-Statistik-Funktionen)"""
    
    def __init__(self,einzelplatz="ja",kwargs=None):
        verwaltungMainObjekt.verwaltungMainObjekt.__init__(self,einzelplatz=einzelplatz,subclass_args=kwargs)

    def hallo(self):
        """Zum Testen"""
        print "<p>hallo<p>"

    def GemeindekarteiReportlabPdf(self):
        print "Content-type: text/html\n"
        print """<H3>Diese Funktion erzeugt ein Adressbuch zum Ausdrucken im PDF-Format. Es werden die neuesten Daten aus der Datenbank verwendet Berechnung und bertragung knnen 1-2 Minuten dauern - bitte Geduld!</H3>"""
        print """<H3>Achtung: Der Microsoft-Internet-Explorer ist dafr bekannt, dass er u.U. Probleme hat bei der Direktanzeige von PDF-Dateien (nicht nur bei dieser Webseite). Lsungsmglichkeiten:</H3>"""
        print """<li>Verwenden Sie einen leistungsfhigeren Browser, z.B. "Mozilla" (www.mozilla.org)."""
        print """<li>Klicken Sie im Internetexplorer mit der rechten Maustaste auf den Adressbuch-Link. Whlen Sie "...speichern unter", ndern Sie den vorgegebenen Dateinamen auf "adressbuch.pdf" und speichern Sie an der gewnschten Stelle. ffnen Sie die Datei anschlieend mit dem "Acrobat-Reader"."""
        print "<p>"
        htmlwerkzeug = htmlutilities.HtmlUtilities()
        print htmlwerkzeug.smartlink(self.schaltzentrale, {'schluessel': "A4","Aktion": "GemeindekarteiReportlabPdfDurchfuehren"},"Adressbuch erstellen (DIN A4)")
        print "<p>"
        print htmlwerkzeug.smartlink(self.schaltzentrale, {'schluessel': "A5","Aktion": "GemeindekarteiReportlabPdfDurchfuehren"},"Adressbuch erstellen (DIN A5)")

##    def GemeindekarteiReportlabPdf(self):
##        print self.htmlintro
##        print """<H3>Diese Funktion wird z.zT. bearbeitet und steht nicht zur Verfgung.</H3>"""

##    def GemeindekarteiReportlabPdfDurchfuehren(self):
##        import gemeindekarteimysql
##        # mu schon hier stehen, denn die PDF-Funktion druckt Debug-Infos nach Standard-Out.
##        g = gemeindekarteimysql.Gemeindekartei(self.MysqlDatenbank,self.Buchungsjahr)
##        s = g.emkAdressenReportlabPDF(format=self.schluessel)
##        print "Content-type: application/pdf\n"
##        print s

    def GemeindekarteiReportlabPdfDurchfuehren(self):
        import reportpdf
        # mu schon hier stehen, denn die PDF-Funktion druckt Debug-Infos nach Standard-Out.
        r = reportpdf.emkAdressenReportlabPDF(self.MysqlDatenbank,self.Buchungsjahr,format=self.schluessel)
        s = r.buildStory()
        print "Content-type: application/pdf\n"
        print s

    def GemeindekarteiAuswahlSpeichern(self):
        print self.htmlintro
        htmlwerkzeug = htmlutilities.HtmlUtilities()
        auswahl = []
        auswahl.append(htmlwerkzeug.smartlink(self.schaltzentrale, {'schluessel': "","Aktion": "GemeindekarteiAuswahlDruckliste"},"Druck-Liste"))
        auswahl.append(htmlwerkzeug.smartlink(self.schaltzentrale, {'schluessel': "","Aktion": "AuswahlExportieren"},"CSV-Export"))
        auswahl.append(htmlwerkzeug.smartlink(self.schaltzentrale, {'schluessel': "","Aktion": "GemeindekarteiSerienbriefAnzeigen"},"Serienbrief"))
        auswahl.append(htmlwerkzeug.smartlink(self.schaltzentrale, {'schluessel': "","Aktion": "GemeindekarteiEmailRundschreibenAnzeigen"},"EMail-Rundschreiben"))
        statewerkzeug = state.State(self.User)
        try:
            if self.mzliste:
                statewerkzeug.variableSetzen("letztesObjekt",self.mzliste)
            elif self.formdict.has_key("MZ"):
                statewerkzeug.variableSetzen("letztesObjekt",[self.formdict["MZ"]])
                # Vorsicht - formdict mu als Liste bergeben werden!
                #self.steuerflag = 0 # Signal fr GemeindekarteiSerienbriefAnzeigen
                #self.GemeindekarteiSerienbriefAnzeigen()
                #return
            else:
                pass # Wenn es z.B. von SelectBefehlBefehlDirektAusfuehren aufgerufen wird.
            print "<H3>Auswahl gespeichert! Was mchten Sie mit der Auswahl tun?</H3>"
        except:
            print "<H3>Auswahl konnte nicht gespeichert werden!</H3>"
        print htmlwerkzeug.tabelleMitInhalt([auswahl])

    def GemeindekarteiSerienbriefAnzeigen(self):
        if self.steuerflag:
            print self.htmlintro
        gemeindekartei = gemeindeverwaltung.GemeindekarteiBearbeiten(self.MysqlDatenbank,self.Buchungsjahr)
        try:
            vorlagen = gemeindekartei.alleVorlagen()
            webarray = optionenweb.OptionenWeb(self.MysqlDatenbank,self.schaltzentrale)
            print """<H3>Achtung, die Reaktion des Programms kann bei einer groen Auswahl von Datenstzen sprbare Wartezeiten erfordern. Alle Vorlagen:</H3>"""
            print webarray.vorlagenAnzeigen(vorlagen)
        except:
            print """<H4>Falsches/nicht vorhandenes Vorlagenverzeichnis? Bitte unter "Optionen" prfen!</H4>"""

    def GemeindekarteiVorlagenAnzeigen(self):
        print self.htmlintro
        gemeindekartei = gemeindeverwaltung.GemeindekarteiBearbeiten(self.MysqlDatenbank,self.Buchungsjahr)
        try:
            vorlagen = gemeindekartei.alleVorlagen()
            webarray = optionenweb.OptionenWeb(self.MysqlDatenbank,self.schaltzentrale)
            print "<H3>Whlen Sie eine Vorlage zum Bearbeiten:</H3>"
            print webarray.serienbriefVorlagenAnzeigen(vorlagen)
        except:
            print """<H4>Falsches/nicht vorhandenes Vorlagenverzeichnis? Bitte unter "Optionen" prfen!</H4>"""

    def GemeindekarteiAuswahlDruckliste(self):
        print self.htmlintro
        gemeindekartei = gemeindeverwaltung.GemeindekarteiBearbeiten(self.MysqlDatenbank,self.Buchungsjahr)
        statewerkzeug = state.State(self.User)
        liste = statewerkzeug.variableHolen("letztesObjekt")
        dictarray = gemeindekartei.schluesselListeSuchen(liste)
        textwerkzeug = textutilities.Textutilities()
        dictarray = textwerkzeug.privatStattDienstlichDictarray(dictarray) # verndert nur etwas bei emkadressen_neu
        webarray = gemeindekarteiweb.GemeindekarteiWeb(self.MysqlDatenbank,self.Buchungsjahr,dictarray,self.schaltzentrale,gemeindekartei.alleSpalten())
        #print self.htmlintro
        print webarray.datensatzkurztabelle()

    def GemeindekarteiEmailRundschreibenAnzeigen(self):
        print self.htmlintro
        htmlwerkzeug = htmlutilities.HtmlUtilities()
        gemeindekartei = gemeindeverwaltung.GemeindekarteiBearbeiten(self.MysqlDatenbank,self.Buchungsjahr)
        statewerkzeug = state.State(self.User)
        liste = statewerkzeug.variableHolen("letztesObjekt")
        #dictarray = gemeindekartei.schluesselListeSuchen(liste)
        email,noemail = gemeindekartei.emailListeSuchen(liste,alsDictarray="nein")
        print """<H3>Zum Verschicken mit ihrem eigenen E-Mail-Programm klicken Sie %s.<br></H3>""" % htmlwerkzeug.emaillink(email,"hier")
        print """<H3>Oder: E-Mail verschicken vom Server (ohne Anhnge): Bitte fllen Sie die Felder aus</H3>"""
        liste = (('Absender_Name',self.User),('Absender_EMail',verwaltungMainServer.CHECKIN[self.Datenbank][self.User][1]),('Betreff',''),('Nachricht',''))
        print htmlwerkzeug.eingabeFormularAusgeben(liste,self.schaltzentrale,hidden=(('Aktion','GemeindekarteiEmailRundschreibenDurchfuehren'),),submit='Abschicken',vierspaltig="nein",textareafelder=["Nachricht"])

    def GemeindekarteiEmailRundschreibenDurchfuehren(self):
        # Achtung, Test:
        # Das Schreiben der E-Mail kann lnger gedauert haben, so da jetzt ein
        # falsches "letztesObjekt" verwendet wird. => es mu wieder verschiedene
        # User-Verzeichnisse geben.
        print self.htmlintro
        gemeindekartei = gemeindeverwaltung.GemeindekarteiBearbeiten(self.MysqlDatenbank,self.Buchungsjahr)
        statewerkzeug = state.State(self.User)
        liste = statewerkzeug.variableHolen("letztesObjekt")
        #dictarray = gemeindekartei.schluesselListeSuchen(liste)
        email,noemail = gemeindekartei.emailListeSuchen(liste)
        emailliste,noemailliste = gemeindekartei.emailListeSuchen(liste,alsDictarray="nein")
        text = """%s\n\n%s\nvon %s (EMail: %s)""" % (self.formdict.get("Nachricht","-"),gemeindekartei.timenow(),self.formdict.get("Absender_Name","-"),self.formdict.get("Absender_EMail","-"))
        subject = self.formdict.get("Betreff","-")
        absender = self.formdict.get("Absender_EMail","-")
        # Achtung, Test:
        try:
            gemeindekartei.emailSenden(text=text,liste=emailliste,subject=subject,absender=absender)
            webarray = gemeindekarteiweb.GemeindekarteiWeb(self.MysqlDatenbank,self.Buchungsjahr,email,self.schaltzentrale,gemeindekartei.alleSpalten())
            print """<H4>An folgende Personen konnte eine E-Mail versendet werden:</H4>"""
            print webarray.datensatzkurztabelle()
            webarray = gemeindekarteiweb.GemeindekarteiWeb(self.MysqlDatenbank,self.Buchungsjahr,noemail,self.schaltzentrale,gemeindekartei.alleSpalten())
            print """<H4>An folgende Personen konnte keine E-Mail versendet werden (falsche/fehlende EMail-Adresse):</H4>"""
            print webarray.datensatzkurztabelle()
        except:
            print """<H3>Beim Versand der E-Mail ist ein Fehler aufgetreten. Fehlende Internet-Verbindung? Falscher Eintrag unter "Optionen/Grundeinstellungen/EMailServer"? Niemand mit E-Mail-Adresse in der Auswahl dabei?</H3>"""

    def GemeindekarteiSerienbriefDurchfuehren(self):
        print self.htmlintro
        htmlwerkzeug = htmlutilities.HtmlUtilities()
        gemeindekartei = gemeindeverwaltung.GemeindekarteiBearbeiten(self.MysqlDatenbank,self.Buchungsjahr,self.User)
        statewerkzeug = state.State(self.User)
        liste = statewerkzeug.variableHolen("letztesObjekt")
        dir = gemeindekartei.serienbriefVerzeichnisUser()
        try:
            alleBriefe = gemeindekartei.serienbriefErstellen(self.User,self.schluessel,liste)
            statewerkzeug.variableSetzen("letztesObjekt",alleBriefe)
            # print alleBriefe
            print "<H4>Die Serienbriefe befinden sich im Verzeichnis %s.</H4>" % dir
            smartlink =  htmlwerkzeug.smartlink(self.schaltzentrale,{'Aktion':'GemeindekarteiSerienbriefeDrucken'},"Ausdrucken mit OpenOffice")
            print """<p><H3>%s (Kann bei vielen Serienbriefen lange dauern)</H3>""" % smartlink
        except:
            print """<H4>Die Serienbriefe konnten nicht gespeichert werden.
            Bitte Schreibrechte im Serienbriefverzeichnis %s prfen!</H4>""" % dir

    def GemeindekarteiSerienbriefeDrucken(self):
        print self.htmlintro
        gemeindekartei = gemeindeverwaltung.GemeindekarteiBearbeiten(self.MysqlDatenbank,self.Buchungsjahr,self.User)
        statewerkzeug = state.State(self.User)
        htmlwerkzeug = htmlutilities.HtmlUtilities()
        liste = statewerkzeug.variableHolen("letztesObjekt")
        #print liste
        #stringliste = string.join(liste," ")
        test = gemeindekartei.serienbriefAusdruckenOpenOffice(liste)
        if not test:
            print "Kein Ausdruck mglich. OpenOffice nicht installiert? Falscher Pfad unter Optionen/Textverarbeitung eingetragen?"
        else:
            print "<H3>Druckbefehl abgeschlossen!</H3>"

    def GemeindekarteiVorlageBearbeiten(self):
        self.GemeindekarteiSerienbriefDirektanzeige(datei_erzwingen=1)

    def BaukontoSpendenquittungBearbeiten(self):
        self.GemeindekarteiSerienbriefDirektanzeige(datei_erzwingen=1)

    def BaukontoSpendenquittungDirektanzeige(self):
        self.GemeindekarteiSerienbriefDirektanzeige()

    def GemeindekarteiSerienbriefDirektanzeige(self,datei_erzwingen=0):
        """TODO: vgl. die - bisher identische - Funktion in FiBu-Statistik."""
        # mit datei_erzwingen kann die Anzeige ber Netzwerk abgeschaltet werden,
        # unabhngig von verwaltungMainServer.EINZELPLATZ_NEU
        pdf = 0
        if self.formdict.has_key("pdf"):
            pdf = 1
        gemeindekartei = gemeindeverwaltung.GemeindekarteiBearbeiten(self.MysqlDatenbank,self.Buchungsjahr,self.User)
        statewerkzeug = state.State(self.User)
        htmlwerkzeug = htmlutilities.HtmlUtilities()
        liste = []
        if self.flag != "GemeindekarteiVorlageBearbeiten" and self.flag != "BaukontoSpendenquittungBearbeiten":
            if (self.schluessel[-3:] != "sxw") or (self.flag == "BaukontoSpendenquittungDirektanzeige"):
                liste = [statewerkzeug.variableHolen("letztesObjekt")[0]]
                # es wird nur der erste "Serienbrief" bercksichtigt
            elif (self.schluessel[-3:] == "sxw") and (self.flag == "GemeindekarteiSerienbriefDirektanzeige"):
                liste = statewerkzeug.variableHolen("letztesObjekt")
        auswahlliste = None
        try:
            if self.flag == "BaukontoSpendenquittungDirektanzeige":
                auswahlliste = statewerkzeug.variableHolen("letzteBuchungsliste")
        except:
            auswahlliste = None # fr normale Serienbriefe
        anzeige = ""
        # *********** Achtung, nicht vergessen: Linux-Pfad fr lokale PDF-Anzeige ist in config.py
        try:
            if self.flag == "GemeindekarteiSerienbriefDirektanzeige" or self.flag == "BaukontoSpendenquittungDirektanzeige":
                datei = gemeindekartei.serienbriefErstellen(self.User,self.schluessel,liste,alleSpenden="ja",auswahlliste=auswahlliste,pdf=pdf)[0]
            elif (self.flag == "GemeindekarteiVorlageBearbeiten" or self.flag == "BaukontoSpendenquittungBearbeiten"):
                datei = os.path.join(gemeindekartei.serienbriefVerzeichnis(),self.schluessel) # Fr das Bearbeiten der Vorlagen            
            # self.schluessel enthlt den Namen der Vorlage. Mit alleSpenden="ja" kann man "mogeln": es kann der Ausdruck von
            # ausgewhlten Spenden erzwungen werden (Vorsicht...)
            datei = os.path.normpath(datei)
            textverarbeitung = os.path.normpath(gemeindekartei.Optionen.optionen["Textverarbeitung"])            
            befehl = """%s %s""" % (textverarbeitung,datei)
            if (sys.platform[:3] == "win") and (verwaltungMainServer.EINZELPLATZ_NEU == "ja"):
                print self.htmlintro
                if not os.path.exists(textverarbeitung):
                    os.system("start %s" % datei)
                    print datei # Anzeige und Patch gleichzeitig, damit die Seite angezeigt wird.
                    # Wir versuchen alternativ die registrierte Windows-Standardanwendung
                    # fr RTF-Dateien bzw. SXW-Dateien
                    # time.sleep(1)
                    anzeige = "mit Standard-Textverarbeitung. Nach dem Ausdrucken die Textverarbeitung bitte wieder wegklicken!"
                else:
                    # Ein Patch, damit es keine Probleme gibt: Beim Ausdruck aus dem
                    # Explorer soll die Standardtextverarbeitung benutzt werden.
                    # auerdem: unter XP wir sonst (manchmal? und: warum?) anschlieend angezeigt
                    # vom Browser: "Seite kann nicht angezeigt werden" o..
                    # *** Achtung, Trick: keinen DOS-"start"-Befehl verwenden zur
                    # Erzeugung eines unabhngigen Prozesses - s.u.
                    pass
                    # print datei
                    # time.sleep(1)
                    os.system("%s" % befehl) 
                    # time.sleep(1)
                    anzeige = "mit " + textverarbeitung + ". Nach dem Bearbeiten/Ausdrucken die Textverarbeitung bitte wieder wegklicken!" 
            elif verwaltungMainServer.EINZELPLATZ_NEU == "ja" or datei_erzwingen:
                print self.htmlintro
                if not os.path.exists(textverarbeitung):
                    #anzeige = "nicht mglich - falscher Pfad unter Optionen/Textverarbeitung angegeben!" # gendert!
                    os.system("start %s" % datei)
                    print datei # Anzeige und Patch gleichzeitig, damit die Seite angezeigt wird.
                    # Wir versuchen alternativ die registrierte Windows-Standardanwendung
                    # fr RTF-Dateien bzw. SXW-Dateien vgl. oben
                else:
                    if pdf:
                        befehl = """%s %s""" % (verwaltungMainServer.PDF_READER,datei)
                        # lokaler PDF-Reader unter Linux
                    os.system("%s" % befehl) 
                    #os.system("%s&" % befehl) # Start der Textverarbeitung als eigener Proze - besser nicht, wegen
                    #anschlieend herumgeisternden Halb-Prozessen? => Passiert, wenn man den Server abschaltet, bevor
                    # man das Fenster der Textverarbeitung weggeklickt hat.
                    anzeige = "mit " + textverarbeitung
            elif verwaltungMainServer.EINZELPLATZ_NEU == "nein" and not datei_erzwingen:
                if datei[-3:].lower() == "rtf":
                    print "Content-type: text/rtf\n"
                elif datei[-3:].lower() == "sxw":
                    print "Content-type: application/vnd.sun.xml.writer\n"
                elif datei[-3:].lower() == "pdf":
                    print "Content-type: application/pdf\n"
                datei_objekt = open(datei,"rb")
                text = datei_objekt.read()
                datei_objekt.close()
                # Achtung, Test:
                try:
                    os.remove(datei)
                except:
                    pass
                print text
                return
            if not pdf:
                print "<H4>Anzeige %s</H4>" % anzeige
            if self.flag == "GemeindekarteiSerienbriefDirektanzeige" and not pdf:
                smartlink =  htmlwerkzeug.smartlink(self.schaltzentrale,{'schluessel': self.schluessel,'Aktion':'GemeindekarteiSerienbriefDurchfuehren'},"Serienbrief(e) speichern")
                print """<p><H3>%s</H3>""" % smartlink
            # Achtung, Test: Anzeige verlagert nach verwaltungMainFibuStatistik.BaukontoAuswahlSpeichern
            elif self.flag == "BaukontoSpendenquittungDirektanzeige" and verwaltungMainServer.EINZELPLATZ_NEU == "ja":
                smartlink1 = htmlwerkzeug.smartlink(self.schaltzentrale,{'Aktion':'BaukontoSpendenquittungFehldruck'},"Fehldruck oder Probedruck")
                smartlink2 =  htmlwerkzeug.smartlink(self.schaltzentrale,{'Aktion':'BaukontoSpendenquittungRegistrieren'},"Spendenquittung registrieren")
                print "%s<p><H3>%s</H3>" % (smartlink1, smartlink2)
            elif (self.flag == "GemeindekarteiVorlageBearbeiten" or self.flag == "BaukontoSpendenquittungBearbeiten"):
                # Achtung, Test: was machen wir damit bei der Netzwerkversion?
                print "<H3>Gewhlte Vorlage bearbeitet!</H3>"
        except:
            # TODO: andere Ausnahme fr Vorlagenbearbeitung
            dir = gemeindekartei.serienbriefVerzeichnisUser()
            print """<H4>Die Serienbriefe konnten nicht gespeichert werden.
            Bitte Schreibrechte im Serienbriefverzeichnis %s prfen!</H4>""" % dir
   



class verwaltungMainFunktionEinzelplatz(verwaltungMainFunktion):
    def __init__(self,einzelplatz,kwargs):
        verwaltungMainFunktion.__init__(self,einzelplatz,kwargs=kwargs)



def objekt_holen(einzelplatz="ja",**kwargs):
    if einzelplatz == "ja":
        return verwaltungMainFunktionEinzelplatz(einzelplatz,kwargs)

if __name__ == "__main__":
    test= objekt_holen(einzelplatz="ja",Buchungsjahr="2003")
    print test
    print test.Buchungsjahr
