#coding: latin-1
#Ab Python2.3 ist die uncodierte Verwendung von Umlauten deprecated.
import normalDate
import datumutilities
import textutilities
import sys
import re
import string
import verwaltungmysql
import abkuerzungenmysql
import sortieren
import types
import os
import gemeindekarteiweb
import gemeindekarteimysql
import optionen
import verschiedeneUtilities
import verwaltungMainServer

primaerkartei = 'LfdNummer'
tabuschluessel = [primaerkartei,'LetzteAenderung','BearbeitetVon']
Benutzername = ""
User = ""
# wird von verwaltungMainServer gesetzt


class ZuordnungenNormal(gemeindekarteimysql.GemeindekarteiNormal):

    global primaerkartei,Benutzername,tabuschluessel

    def __init__(self,MysqlDatenbank,buchungsjahr,datenbank="dummy",tabelle="zuordnungen"):
        gemeindekarteimysql.GemeindekarteiNormal.__init__(self,MysqlDatenbank,buchungsjahr,datenbank,tabelle)

    def abkuerzungenPruefen(self,dict,alleAbkuerzungen=[]):
        return gemeindekarteimysql.GemeindekarteiNormal.abkuerzungenPruefen(self,dict)

    def zuordnungenZuPerson(self,schluessel):
        return self.eintragSuchfunktion({"MZ": schluessel})

    def eintragPruefen(self,pruefdict):
        pass

    def schluesselSuchen(self,schluessel,defaultsuche="nein",eintrag_pruefen="nein",kategorie=primaerkartei):
        return gemeindekarteimysql.GemeindekarteiNormal.schluesselSuchen(self,schluessel=schluessel,defaultsuche=defaultsuche,eintrag_pruefen=eintrag_pruefen,kategorie=kategorie)

    def eintragSuchfunktion(self,suchdict,datumumwandeln="nein",defaultsuche="nein",sortierkategorie="WerkEinrichtung",abkuerzungen=["-"]):
        # Es soll ohne Bercksichtung von Abkrzungen gesucht werden, deshalb ["-"], vgl. die Superklasse
        return gemeindekarteimysql.GemeindekarteiNormal.eintragSuchfunktion(self,suchdict=suchdict,datumumwandeln=datumumwandeln,defaultsuche=defaultsuche,sortierkategorie=sortierkategorie,abkuerzungen=abkuerzungen)

    def neuerEintrag(self,neudict,primaerdummy=primaerkartei,schluesselwert=None,tabelle=None,protokoll="nein",alleAbkuerzungen=[],tabuneu=tabuschluessel):
        return gemeindekarteimysql.GemeindekarteiNormal.neuerEintrag(self,neudict,primaerdummy=primaerdummy,schluesselwert=schluesselwert,tabelle=tabelle,protokoll="nein",alleAbkuerzungen=alleAbkuerzungen,tabuneu=tabuneu)

    def eintragLoeschen(self,primaerdummy=primaerkartei,schluesselwert=None,protokoll="nein"):
        # TODO: ggf. in gemeindekartei auf Vorhandensein prfen.
        return gemeindekarteimysql.GemeindekarteiNormal.eintragLoeschen(self,primaerdummy=primaerdummy,schluesselwert=schluesselwert,protokoll=protokoll)

    def schluessellisteSuchen(self,schluesselliste,sortierkategorie="WerkEinrichtung",zusatzbedingung="",rueckgabe="dictionary",primaerschluessel=primaerkartei):
        return gemeindekarteimysql.GemeindekarteiNormal.schluessellisteSuchen(self,schluesselliste=schluesselliste,sortierkategorie=sortierkategorie,zusatzbedingung=zusatzbedingung,rueckgabe=rueckgabe,primaerschluessel=primaerschluessel)

    def eintragAendern(self,aenderungsdict,primaerschluessel=primaerkartei,schluessel="",protokoll="nein"):
        return gemeindekarteimysql.GemeindekarteiNormal.eintragAendern(self,aenderungsdict=aenderungsdict,primaerschluessel=primaerschluessel,schluessel=schluessel,protokoll=protokoll,tabu=tabuschluessel+["MZ","Name"])

    def sortierteListe(self,sortierkategorie="WerkEinrichtung",spaltenliste=None,rueckgabe="dictionary",nurAktiveGlieder="nein"):
        return gemeindekarteimysql.GemeindekarteiNormal.sortierteListe(self,sortierkategorie=sortierkategorie,spaltenliste=spaltenliste,rueckgabe=rueckgabe,nurAktiveGlieder=nurAktiveGlieder)

    def eintragVergleichen(self,schluessel,vergleichdict,nichtvergleichen=tabuschluessel,kategorie=primaerkartei):
        return gemeindekarteimysql.GemeindekarteiNormal.eintragVergleichen(self,schluessel=schluessel,vergleichdict=vergleichdict,nichtvergleichen=nichtvergleichen,kategorie=kategorie)

    def alleWerkeKonferenz(self,konferenz):
        wherestring = """where Konferenz like "%s" """ % konferenz
        return self.werteListe(kategorie="WerkEinrichtung",distinct="ja",wherestring=wherestring,leere_entfernen="ja")

    def uebersichtListe(self):
        return self.sortierteListe()
        

class ZuordnungenEmKAdressen_Neu(ZuordnungenNormal):

    global primaerkartei,Benutzername,tabuschluessel

    def __init__(self,MysqlDatenbank,buchungsjahr,datenbank="dummy",tabelle="tblAufbau"):
        ZuordnungenNormal.__init__(self,MysqlDatenbank,buchungsjahr,datenbank,tabelle)
        self.gemeindekartei = gemeindekarteimysql.Gemeindekartei(MysqlDatenbank=MysqlDatenbank,buchungsjahr=buchungsjahr)
        self.BezEinrichtungPerson = verwaltungmysql.MySQLZugriff(MysqlDatenbank=MysqlDatenbank,datenbank=datenbank,tabelle="tblBezEinrichtungPerson")
        self.BezEinrichtungAdresse = verwaltungmysql.MySQLZugriff(MysqlDatenbank=MysqlDatenbank,datenbank=datenbank,tabelle="tblBezEinrichtungAdresse")
        #self.EinrichtungBank = verwaltungmysql.MySQLZugriff(MysqlDatenbank=MysqlDatenbank,datenbank=datenbank,tabelle="tblEinrichtungBank")
        #self.Einrichtungen = verwaltungmysql.MySQLZugriff(MysqlDatenbank=MysqlDatenbank,datenbank=datenbank,tabelle="tblEinrichtungen")
        self.EinrichtungBank = gemeindekarteimysql.Gemeindekartei(MysqlDatenbank=MysqlDatenbank,buchungsjahr=buchungsjahr,tabelle="tblEinrichtungBank")
        self.Einrichtungen = gemeindekarteimysql.Gemeindekartei(MysqlDatenbank=MysqlDatenbank,buchungsjahr=buchungsjahr,tabelle="tblEinrichtungen")
        self.BezirkeKonferenz = {"NJK": "A.7.1.2", "OJK": "A.7.2.2", "SJK": "A.7.3.2"}
        self.DistrikteKonferenz = {"NJK": "A.7.1.1", "OJK": "A.7.2.1", "SJK": "A.7.3.1"}

    def eintragSuchfunktion(self,suchdict,datumumwandeln="nein",defaultsuche="nein",sortierkategorie="Nr",abkuerzungen=["-"]):
        # Es soll ohne Bercksichtung von Abkrzungen gesucht werden, deshalb ["-"], vgl. die Superklasse
        temp = ZuordnungenNormal.eintragSuchfunktion(self,suchdict=suchdict,datumumwandeln=datumumwandeln,defaultsuche=defaultsuche,sortierkategorie=sortierkategorie,abkuerzungen=abkuerzungen)
        return self.bedingtesSortieren(temp,sortierkategorie)

    def einrichtungSuchfunktion(self,AdrID):
        # sucht die Einrichtungsbezeichnung zu einer AdrID
        try:
            temp = self.BezEinrichtungAdresse.eintragHolen("""AdrID like "%s" """ % AdrID)
            return temp[0]
        except:
            return "-"

    def adresseSuchfunktion(self,mz):
        # gibt einen Adressendictarray zurck.
        temp = self.Einrichtungen.eintragSuchfunktion({"MZ": mz},sortierkategorie="MZ",abkuerzungen=["-"],abk_liste=["-"])
        return temp

    def bankSuchfunktion(self,LfdNummer):
        # gibt einen einzelnen Bankdictarray zurck.
        temp = self.EinrichtungBank.eintragSuchfunktion({"LfdNummer": LfdNummer},sortierkategorie="LfdNummer",abkuerzungen=["-"],abk_liste=["-"])
        return temp

    def adresseAendern(self,aenderungsdict,schluessel,protokoll="ja"):
        tabu = tabuschluessel + ['AdrID','User1','User2','User3','User4','DatumErstellt','DatumZuletztGeaendert','Notizen','Bezirk','MZ']
        # die Protokollfunktion darf nicht aus gemeindekarteimysql aufgerufen werden:
        altdict = self.adresseSuchfunktion(schluessel)[0]
        aenderungsdict = self.Einrichtungen.tabuschluesselEntfernen(aenderungsdict,tabu) # eine Doppelung
        if verwaltungMainServer.PROTOKOLLIEREN.has_key(self.Datenbankname) and protokoll=="ja":
            self.emailProtokoll(self.adresseAendernProtokoll(altdict,aenderungsdict),Benutzername)
        return self.Einrichtungen.eintragAendern(aenderungsdict=aenderungsdict,primaerschluessel="MZ",schluessel=schluessel,protokoll="nein",tabu=tabu,altdict=altdict)

    def adresseAendernProtokoll(self,altdict,aenderungsdict):
        ErID = self.einrichtungSuchfunktion(altdict["AdrID"])["ErID"]
        text = "Liebe(r) Benutzer(in) %s,\ndies ist ein automatisches Protokoll.\nArt des Zugriffs: nderung einer Einrichtungs-Adresse\nEinrichtung %s = %s \n\nNeue Daten:\n" % (Benutzername,ErID,altdict["Bezeichnung"])
        for i in aenderungsdict.keys():
            text += "%s: %s => %s\n" % (i,altdict[i],aenderungsdict[i])
        return text

    def bankAendern(self,aenderungsdict,schluessel,protokoll="ja"):
        tabu = tabuschluessel + ['BkID','BezID','User1','User2','User3','User4','DatumErstellt','DatumZuletztGeaendert','LfdNummer']
        # die Protokollfunktion darf nicht aus gemeindekarteimysql aufgerufen werden:
        altdict = self.bankSuchfunktion(schluessel)[0]
        aenderungsdict = self.EinrichtungBank.tabuschluesselEntfernen(aenderungsdict,tabu) # eine Doppelung
        if verwaltungMainServer.PROTOKOLLIEREN.has_key(self.Datenbankname) and protokoll=="ja":
            self.emailProtokoll(self.bankAendernProtokoll(altdict,aenderungsdict),Benutzername)
        return self.EinrichtungBank.eintragAendern(aenderungsdict=aenderungsdict,primaerschluessel="LfdNummer",schluessel=schluessel,protokoll="nein",tabu=tabu,altdict=altdict)

    def bankAendernProtokoll(self,altdict,aenderungsdict):
        ErID = self.einrichtungSuchfunktion(altdict["BezID"])["ErID"]
        text = "Liebe(r) Benutzer(in) %s,\ndies ist ein automatisches Protokoll.\nArt des Zugriffs: nderung einer Einrichtungs-Bankverbindung\nEinrichtung %s\n\nNeue Daten:\n" % (Benutzername,ErID)
        for i in aenderungsdict.keys():
            text += "%s: %s => %s\n" % (i,altdict[i],aenderungsdict[i])
        return text

    def schluessellisteSuchen(self,schluesselliste,sortierkategorie="Nr",zusatzbedingung="",rueckgabe="dictionary",primaerschluessel=primaerkartei):
        temp = ZuordnungenNormal.schluessellisteSuchen(self,schluesselliste=schluesselliste,sortierkategorie=sortierkategorie,zusatzbedingung=zusatzbedingung,rueckgabe=rueckgabe,primaerschluessel=primaerschluessel)
        return self.bedingtesSortieren(temp,sortierkategorie)

    def eintragAendern(self,aenderungsdict,primaerschluessel=primaerkartei,schluessel="",protokoll="nein"):
        return ZuordnungenNormal.eintragAendern(self,aenderungsdict=aenderungsdict,primaerschluessel=primaerschluessel,schluessel=schluessel,protokoll=protokoll,tabu=tabuschluessel)

    def sortierteListe(self,sortierkategorie="Nr",spaltenliste=None,rueckgabe="dictionary",nurAktiveGlieder="nein"):
        temp = ZuordnungenNormal.sortierteListe(self,sortierkategorie=sortierkategorie,spaltenliste=spaltenliste,rueckgabe=rueckgabe,nurAktiveGlieder=nurAktiveGlieder)
        return self.bedingtesSortieren(temp,sortierkategorie)

    def bedingtesSortieren(self,dictlist,sortierkategorie):
        if sortierkategorie != "Nr":
            return dictlist
        else:
            return self.Sortierwerkzeug.emk_ordnungsnummer_sort(dictlist)

    def uebersichtListe(self,sortierkategorie="Nr",spaltenliste=None,rueckgabe="dictionary",nurAktiveGlieder="nein",tiefe=2,extra=None):
        """Gibt einen dictarray zurck, der nur Oberkategorien enthlt, z.B. "A", "A.1". Per
        default eine Unterkategorie."""
        if extra is None:
            extra = ("A.7.1","A.7.2","A.7.3","A.7.1.2","A.7.2.2","A.7.3.2")
        dictarray = self.sortierteListe(sortierkategorie=sortierkategorie)
        templist = []
        for i in dictarray:
            try:
                l = len(string.split(i["Nr"],"."))
                if l <= tiefe or i["Nr"] in extra:
                    templist.append(i)
            except:
                pass
        return templist

    def istBezirk(self,ordnungsnummer):
        if ordnungsnummer[0:7] in ("A.7.1.2","A.7.2.2","A.7.3.2"):
            return 1
        else:
            return 0

    def neueZuordnung(self,schluessel,einrichtung,protokoll="ja"):
        """bergeben wird die MZ(s.u.) und die Ordnungsnummer (ErID)
        der Einrichtung."""
        neudict = {"ErID": einrichtung}
        person = self.gemeindekartei.schluesselSuchen(schluessel)[0]
        id = person["ID"]
        neudict["PID"] = id
        neudict["BearbeitetVon"] = Benutzername
        self.BezEinrichtungPerson.neuerEintragDirekt(neudict)  
        einrichtung_name = self.eintragSuchfunktion({"Nr": einrichtung})[0]["Name"]
        flag = self.istBezirk(einrichtung)
        if verwaltungMainServer.PROTOKOLLIEREN.has_key(self.Datenbankname) and protokoll == "ja":
            self.emailProtokoll(self.neueZuordnungProtokoll(person,einrichtung,einrichtung_name,flag),Benutzername)
        if flag:
            # wird zu einem Bezirk der ZK-Deutschland hinzugefgt?
            update = {}
            if person["Bezirk1"] == "-":
                update["Bezirk1"] = einrichtung_name
            else:
                update["Bezirk2"] = einrichtung_name
            self.gemeindekartei.eintragAendern(aenderungsdict=update,schluessel=person["MZ"])
            # Der Bezirk wird in dem (leider redundanten) Bezirksfeld
            # der Personenkartei eingetragen.
            return 1
        else:
            return 0

    def zuordnungLoeschen(self,schluessel,einrichtung,protokoll="ja"):
        """bergeben wird die MZ, nicht die PID s.o."""
        person = self.gemeindekartei.schluesselSuchen(schluessel)[0]
        id = person["ID"]
        befehl = """delete from tblBezEinrichtungPerson where ErID like "%s" and PID like "%s" """ % (einrichtung,id)
        self.Cursor.execute(befehl)
        einrichtung_name = self.eintragSuchfunktion({"Nr": einrichtung})[0]["Name"]
        flag = self.istBezirk(einrichtung)
        if verwaltungMainServer.PROTOKOLLIEREN.has_key(self.Datenbankname) and protokoll == "ja":
            self.emailProtokoll(self.zuordnungLoeschenProtokoll(person,einrichtung,einrichtung_name,flag),Benutzername)
        return flag 

    def neueZuordnungProtokoll(self,person,einrichtung,einrichtung_name,flag):
        #datensatz = self.schluesselSuchen(schluessel)[0]
        text = "Liebe(r) Benutzer(in) %s,\ndies ist ein automatisches Protokoll.\nArt des Zugriffs: Anlegen einer neuen Zuordnung\nPerson: %s, %s (MZ=%s)\n\nNeue Zuordnung zu:\n%s: %s" % (Benutzername,person["Name"],person["Vorname"],person["MZ"],einrichtung,einrichtung_name)
        if flag:
            text += "\n\nAchtung, die neue Zuordnung ist ein Bezirk!\nBitte berprfen Sie die entsprechenden\nEintrge in der Personenkartei."
        return text

    def zuordnungLoeschenProtokoll(self,person,einrichtung,einrichtung_name,flag):
        #datensatz = self.schluesselSuchen(schluessel)[0]
        text = "Liebe(r) Benutzer(in) %s,\ndies ist ein automatisches Protokoll.\nArt des Zugriffs: Lschen einer Zuordnung\nPerson: %s, %s (MZ=%s)\n\nZuordnung gelscht zu:\n%s: %s" % (Benutzername,person["Name"],person["Vorname"],person["MZ"],einrichtung,einrichtung_name)
        if flag:
            text += "\n\nAchtung, die gelschte Zuordnung ist ein Bezirk!\nBitte berprfen Sie die entsprechenden\nEintrge in der Personenkartei."
        return text

    def zuordnungenUnterkategorien(self,einrichtung):
        temp = self.eintragSuchfunktion({"Nr": """%s.*""" % einrichtung})
        if temp[0]:
            return temp
        else:
            # wenn es keine weiteren Unterkategorien gibt:
            return self.eintragSuchfunktion({"Nr": """%s""" % einrichtung})

##    def zuordnungenZuPerson(self,schluessel):
##        # bergeben wird die MZ, nicht die PID!
##        templist = []
##        id = self.gemeindekartei.schluesselSuchen(schluessel)[0]["ID"]
##        temp = self.BezEinrichtungPerson.eintragSuchfunktion({"PID": id})
##        try:
##            zuordnungen = [i["ErID"] for i in temp]
##            for j in zuordnungen:
##                templist.append(self.eintragSuchfunktion({"Nr": j})[0])
##        except:
##            pass # keine Zuordnungen vorhanden
##        return templist
        

    def zuordnungenZuPerson(self,schluessel,nurBezirke=0):
        # bergeben wird die MZ, nicht die PID!
        add = ""
        if nurBezirke:
            add = """ and (a.Nr like "A.7.1.2.%" or a.Nr like "A.7.2.2.%" or a.Nr like "A.7.3.2.%") """
        befehl = """ select a.* from tblAufbau a, tblBezEinrichtungPerson b, gemeindekartei c where c.MZ=%s and c.ID=b.PID and b.ErID=a.Nr%s""" % (schluessel,add) 
        self.Cursor.execute(befehl)
        liste = self.Cursor.fetchall()
        spalten = self.Spaltennamen
        return self.alsDictionary(spalten,liste)

  ##  def personenZuZuordnung(self,schluessel):
##        # bergeben wird der Einrichtungsschlssel, z.B. "A.7.2.2.20"
##        temp = self.BezEinrichtungPerson.eintragSuchfunktion({"ErID": schluessel})
##        templist = []
##        for i in temp:
##            try:
##                templist.append(self.gemeindekartei.eintragSuchfunktion({"ID": i["PID"]})[0])
##            except:
##                pass
##        return templist

    def personenZuZuordnung(self,schluessel):
        # bergeben wird der Einrichtungsschlssel, z.B. "A.7.2.2.20"
        befehl = """select a.* from gemeindekartei a, tblBezEinrichtungPerson b where b.ErID like "%s" and a.ID=b.PID""" % schluessel
        self.Cursor.execute(befehl)
        liste = self.Cursor.fetchall()
        spalten = self.gemeindekartei.Spaltennamen
        return self.Einrichtungen.alsDictionary(spalten,liste)

    def alleWerkeKonferenz(self,konferenz):
        # Achtung, wird hier ganz anders gehandhabt als in der Superklasse.
        pass

    def alleBezirkeKonferenz(self,konferenz):
        return self.zuordnungenUnterkategorien(self.BezirkeKonferenz[konferenz])

    def alleDistrikteKonferenz(self,konferenz):
        return self.zuordnungenUnterkategorien(self.DistrikteKonferenz[konferenz])

    def adressenZuZuordnung(self,einrichtung):
        befehl = """ select b.ErID, a.* from tblEinrichtungen a, tblBezEinrichtungAdresse b where b.ErID like "%s" and a.AdrID=b.AdrID""" % einrichtung
        self.Cursor.execute(befehl)
        liste = self.Cursor.fetchall()
        spalten = ['ErID'] + self.Einrichtungen.Spaltennamen
        return self.Einrichtungen.alsDictionary(spalten,liste)

    def bankZuZuordnung(self,einrichtung):
        befehl = """ select b.ErID, a.* from tblEinrichtungBank a, tblBezEinrichtungAdresse b where b.ErID like "%s" and a.BezID=b.AdrID""" % einrichtung
        self.Cursor.execute(befehl)
        liste = self.Cursor.fetchall()
        spalten = ['ErID'] + self.EinrichtungBank.Spaltennamen
        return self.EinrichtungBank.alsDictionary(spalten,liste)
        

def Zuordnungen(MysqlDatenbank, buchungsjahr,datenbank="dummy",tabelle="zuordnungen"):
    """Factory-Funktion fr die Geschmacksrichtungen."""
    kirche = verschiedeneUtilities.geschmacksrichtung(MysqlDatenbank)
    if kirche != "emkadressen_neu":
        return ZuordnungenNormal(MysqlDatenbank,buchungsjahr,datenbank,tabelle)
    else:
        return ZuordnungenEmKAdressen_Neu(MysqlDatenbank,buchungsjahr,datenbank="dummy",tabelle="tblAufbau")

    
