#coding: latin-1
#Ab Python2.3 ist die uncodierte Verwendung von Umlauten deprecated.


import cPickle

from admin_config import *
###################
# Die u.g. Konstanten wurden bei der Installation erzeugt und in admin_config.py abgelegt:
# 1. schaltzentrale(default: localhost:8000/cgi-bin/verwaltungMainServer.py) = ...
# kann durch den Skript linksumwandeln_py zusammen mit den statischen Html-Dateien
# umgestellt werden
# 2. CGI (default: ./) = ...
# 3. EMAIL_ADMIN = ...
# 4. NAME_ADMIN = ...
####################
CGIDEBUG = 0
if CGIDEBUG:
    # geht erst ab Python 2.2!
    import cgitb
    cgitb.enable()
    print "Content-type: text/html\n"
    # Achtung, macht Cookies unbrauchbar!
#DEBUG = 1 # fr Entwicklungszwecke s.u. - geht nicht mit Cookies!
DEBUG = 0
CHECKIN_ADD = "4g5t" # hartcodierter Zufallswert
DEMOVERSION = 0 # fr die Demoversion im Internet
# ist intern, fr Test- und Demozwecke - sollte normal abgeschaltet sein
GUI = 0
try:
    import Tkinter
    GUI = 1
except:
    pass
# Brauchen wir fr die Updatefunktion

POST_METHOD = 0
# regelt die bertragung von Formulardaten als POST-Request.
# Vorsicht - funktioniert nicht in der Kombination eingebauter cgiserver - Internet-Explorer.
# Das ist ein im Web schon mehrfach dokumentierter Bug. Alle anderen Kombinationen sollten gehen.
# Abschalten macht die bertragenen Daten im Output sichtbar und verhindert eine -
# spter noch zu implementierende - Datei-Upload-Funktion (z.B. fr E-Mail-Anhnge).
POST = ""
if POST_METHOD:
    POST = """ method="POST" enctype="multipart/form-data" """ # vgl. htmlutilies.py, gemeindekarteiweb.py u.a.
SENDMAIL = "/usr/sbin/sendmail"
EMAIL = "anonymous@myhosting.de"
EINZELPLATZ_NEU = "ja"
# steuert die Anzeige von Formularen und Spendenquittung:
# lokal ber Dateianzeige("ja") - oder ber Netzwerk("nein")?
# Bei Netzwerk: kein Open-Office-Direktausdruck mglich, auer im
# lokalen Netzwerk beim Betrieb mit dem eigenenen cgiserver.
# "Serienbriefe" druckt dann auf dem Drucker des Servers, wenn dort
# OpenOffice korrekt eingerichtet ist.
# Bei OpenOffice-sxw-Dokumenten kann auch mit "EinzelDirekt" das ganze Dokument
# mit allen Seiten auf dem Client angezeigt werden.
PROTOKOLLIEREN = {}
# PROTOKOLLIEREN = {"synago": ""}
# Protokoll in Logdatei "protokoll.txt" und als E-Mail an den Admin, vgl. gemeindekarteimysql.py
# SMTPLIB = 0
SMTPLIB = 1 # Versand von E-Mail mit der Python smtplib (bei lokaler Installation empfohlen)?
datenbank_user,datenbank_passwort = "",""

# LOKALE_ADRESSEN = ['127.0.0.1']
# Im Netzwerk sollen manche Aktionen auf bestimmte Client-Adressen beschrnkt
# bleiben (z.B. das Anlegen neuer Datenbanken)
# Beachte: die Angabe hat hier ohne Portnummer zu erfolgen.

datei = open("checkin","rb")
CHECKIN = cPickle.load(datei)
datei.close()

if DEMOVERSION:
    PROTOKOLLIEREN = {"eibenstock": "","musterkartei": "", "testkartei": ""}
    # in der Logdatei auf dem Server und als E-Mail
    EINZELPLATZ_NEU = "nein"
    import demo_passwort
    datenbank_user,datenbank_passwort,CGI = demo_passwort.datenbank_user,demo_passwort.datenbank_passwort,demo_passwort.CGI
    VERTRAULICH = {"emkadressen": "", "eibenstock": "","musterkartei": "", "testkartei": ""}
    # Auf welche Datenbanken nur mit Pawort zugreifen?
    # als Dict wegen des schnellen Hash-Zugriffs.
    # from checkin import CHECKIN
    CHECKIN_ADD = "4g5t"
    SMTPLIB = 0 # Versand ber sendmail o.. s.o.
    EMAIL_ADMIN = "me.simon@t-online.de"
else:
    try:
        import passwort
        # Achtung, akzeptiert in Python2.3 auch lediglich die kompilierte .pyc-Datei!
        # Fr die Sicherheit muss also passwort.py und passwort.pyc gelscht werden, ggf. auch
        # irgendwelche .py~ -Backup-Dateien u..
        datenbank_user,datenbank_passwort = passwort.datenbank_user,passwort.datenbank_passwort
    except:
        datenbank_user = "einzelplatz"
        # Das folgende geht jetzt ber das Webinterface:
       ## if GUI:
##            import guipasswort
##            datenbank_passwort = guipasswort.eingabe()
##        else:
##            from getpass import getpass
##            datenbank_passwort = getpass("Bitte geben Sie das Bezirksreiter-Admin-Passwort ein: ")
##            del getpass
    # from checkin import CHECKIN

einzelplatz = "ja"
# hier wird gesteuert, ob sich mehrere User gleichzeitig einloggen knnen.
# Wird in der Standardversion abgeschaltet. Ist eigentlich nur noch aus historischen
# Grnden (Rckwrtskompatibilitt) notwendig.

# Achten Sie bei einer Vernderung der u.g. Dictionaries,
# da am Beginn ein "{" steht und der letzte gltige Eintrag jew. mit einem "}"
# abgeschlossen wird!

# fr die Demo-Version im Internet:
DEMO_GESPERRT = {#"OptionenAenderungsformular": "", 
                 #"OptionenAenderungenTesten": "", 
                 #"OptionenAenderungenDurchfuehren": "", 
                 #"SelectBefehlDirektEingabe": "", 
                 "NeueDatenbankTesten": "", 
                 "NeueDatenbankAusfuehren": "", 
                 "KopieDatenbankTesten": "", 
                 "KopieDatenbankAusfuehren": "", 
                 "UpdateInfoAnzeigen": "", 
                 "UpdateStarten": "", 
                 "GemeindekarteiRuecksichernAnzeigen": "", 
                 "GemeindekarteiRuecksichernDurchfuehren": "", 
                 #"GemeindekarteiExportieren": "", 
                 "SelectBefehlDirektAusfuehren": "", 
                 "GemeindekarteiImportierenTesten": "", 
                 "GemeindekarteiImportierenDurchfuehren": "", 
                 "DatenSichern": "", 
                 #"AbkuerzungEingabeformular": "",
                 #"AbkuerzungAenderungsformular": "", 
                 #"AbkuerzungAenderungenTesten": "", 
                 #"AbkuerzungAenderungenDurchfuehren": "",
                 #"AbkuerzungLoeschenPruefen": "",
                 #"AbkuerzungLoeschenDurchfuehren": "", 
                 #"AbkuerzungNeuerEintragAnfang": "",
                 #"AbkuerzungNeuerEintragDurchfuehren": "", 
                 #"AbkuerzungUebersicht": "", 
                 #"KontenplanUebersicht": "", 
                 #"KontoAnzeigen": "", 
                 #"KontenplanAenderungenTesten": "", 
                 #"KontenplanAenderungenDurchfuehren": "",
                 #"KontoLoeschenPruefen": "", 
                 #"KontenplanLoeschenDurchfuehren": "", 
                 #"KontenplanNeuerEintragAnfang": "", 
                 #"KontenplanNeuerEintragDurchfuehren": "", 
                 "NeuesBuchungsjahrTesten": "", 
                 "NeuesBuchungsjahrAusfuehren": "", 
                 #"BaukontoBuchungsformular": "", 
                 #"BaukontoSpendeBuchen": "", 
                 #"BaukontoVorlageUebernehmen": "", 
                 #"BaukontoMonatsbeitragBuchen": "", 
                 #"BaukontoBuchungTesten": "", 
                 #"BaukontoBuchungDurchfuehren": "", 
                 #"LoeschenOhneStorno": "", 
                 #"BaukontoGesamtliste": "", 
                 #"BaukontoBuchungAnzeigen": "", 
                 #"BaukontoVorlageAnzeigen": "", 
                 #"BaukontoVorlageLoeschen": "", 
                 #"BaukontoAlsVorlageSpeichern": "", 
                 #"BaukontoVorlagenGesamtliste": "", 
                 #"BaukontoStornoPruefen": "", 
                 #"BaukontoBuchungStornieren": "", 
                 #"BaukontoSpendenquittungDirektanzeige": "", 
                 # Achtung, Test: "", Funktion "umgeleitet":
                 #"BaukontoSpendenquittungDirektanzeige": "", 
                 #"BaukontoSpendenvorlagenAnzeigen": "", 
                 #"BaukontoAuswahlSpeichern": "", 
                 #"BaukontoSpendenquittungRegistrieren": "",
                 #"BaukontoSpendenquittungFehldruck": "", 
                 #"BaukontoSollHabenAlle": "", 
                 #"BaukontoSollHabenUnterkonten": "", 
                 #"BaukontoSollHabenAlleHauptkonten": "", 
                 #"KontoUebersichtAnzeigen": "", 
                 #"KontoUebersichtAnzeigenGemeinden": "", 
                 #"KontoUebersichtAnzeigenGrundstuecke": "", 
                 #"BaukontoBelegnummerReport": "", 
                 #"BaukontoEinzelspenderUebersicht": "", 
                 #"BaukontoGesamtspendenUebersicht": "", 
                 #"BaukontoSpendenquittungenUebersicht": "", 
                 #"HauptkontoUebersichtAnzeigen": "", 
                 #"GrundstueckeUebersichtAnzeigen": "", 
                 #"GemeindekarteiAuswahlSpeichern": "", 
                 #"GemeindekarteiSerienbriefAnzeigen": "", 
                 #"GemeindekarteiAuswahlDruckliste": "",
                 "GemeindekarteiSerienbriefDurchfuehren": "", 
                 "GemeindekarteiSerienbriefeDrucken": "", 
                 #"GemeindekarteiSerienbriefDirektanzeige": "",
                 #"GemeindekarteiVorlagenAnzeigen": "", 
                 "GemeindekarteiVorlageBearbeiten": "", 
                 "BaukontoSpendenquittungBearbeiten": "", 
                 #"GemeindekarteiVeraenderungen": "", 
                 #"GemeindekarteiVeraenderungenDatensaetze": "", 
                 #"GemeindekarteiEingabeformular": "", 
                 #"GemeindekarteiNeueintragBestaetigung": "", 
                 #"GemeindekarteiSuchenDatensatzkurz": "", 
                 #"GemeindekarteiNamensliste": "", 
                 #"GemeindekarteiUngeprueftListe": "", 
                 #"GemeindekarteiDruckliste": "", 
                 #"GemeindekarteiAenderungsformular": "", 
                 #"GemeindekarteiNeuerEintragPruefen": "", 
                 #"GemeindekarteiAenderungenTesten": "", 
                 #"GemeindekarteiAenderungenDurchfuehren": "", 
                 #"GemeindekarteiLoeschenTesten": "", 
                 #"GemeindekarteiLoeschenBestaetigen": "", 
                 #"GemeindekarteiLoeschenDurchfuehren": "", 
                 #"GemeindekarteiNeuerEintragAnfang": "", 
                 #"GemeindekarteiKopierenDurchfuehren": "", 
                 #"GemeindekarteiGeburtstagslisteAusgabe": "", 
                 #"GemeindekarteiKopierenTesten": "", 
                 #"GemeindekarteiGeburtstagslisteAbfrage": "", 
                 "aus": ""}

# einige Aktionen sollen in der Demoversion nicht auf allen Datenbanken zugnglich sein:
ZUSATZSPERRE = {"GemeindekarteiEmailRundschreibenDurchfuehren": ("musterkartei","testkartei")}

# einige Aktionen sollen nur vom Admin ausgefhrt werden,
# und nur dann, wenn er vom gleichen Rechner aus aufruft bzw. von einem
# freigeschalteten vgl. config.LOKALE_ADRESSEN:
LOKAL_ADMIN =    {"OptionenAenderungsformular": "",
                 "OptionenAenderungenTesten": "",
                 "OptionenAenderungenDurchfuehren": "",
                 "SelectBefehlDirektEingabe": "",
                 "NeueDatenbankTesten": "",
                 "NeueDatenbankAusfuehren": "",
                 "KopieDatenbankTesten": "",
                 "KopieDatenbankAusfuehren": "",
                 "UpdateInfoAnzeigen": "",
                 "UpdateStarten": "",
                 "GemeindekarteiRuecksichernAnzeigen": "",
                 "GemeindekarteiRuecksichernDurchfuehren": "",
                 #"GemeindekarteiExportieren": "",
                 "SelectBefehlDirektAusfuehren": "",
                 "GemeindekarteiImportierenTesten": "",
                 "GemeindekarteiImportierenDurchfuehren": "",
                 # "DatenSichern": "",
                 "NeuesBuchungsjahrTesten": "",
                 "NeuesBuchungsjahrAusfuehren": "",
                 "aus": ""}
# Email darf nur von Benutzern mit "mail"-Berechtigung verschickt werden.
MAIL =           {"GemeindekarteiEmailRundschreibenAnzeigen": "",
                 "GemeindekarteiEmailRundschreibenDurchfuehren": ""}

# Einige Aktionen drfen nur von Benutzern mit Schreibberechtigung "w"
# oder vom Admin "a" ausgefhrt werden:
NUR_WRITE =      {"AbkuerzungAenderungenTesten": "",
                 "AbkuerzungAenderungenDurchfuehren": "",
                 "AbkuerzungLoeschenPruefen": "",
                 "AbkuerzungLoeschenDurchfuehren": "",
                 "AbkuerzungNeuerEintragAnfang": "",
                 "AbkuerzungNeuerEintragDurchfuehren": "",
                 "DatenSichern": "", 
                 "ZuordnungAdresseGeaendert": "",
                 "ZuordnungBankGeaendert": "",
                 #"AbkuerzungUebersicht": "",
                 #"KontenplanUebersicht": "",
                 #"KontoAnzeigen": "",
                 #"KontenplanAenderungenTesten": "",
                 #"KontenplanAenderungenDurchfuehren": "",
                 #"KontoLoeschenPruefen": "",
                 #"KontenplanLoeschenDurchfuehren": "",
                 #"KontenplanNeuerEintragAnfang": "",
                 #"KontenplanNeuerEintragDurchfuehren": "",
                 #"NeuesBuchungsjahrTesten": "",
                 #"NeuesBuchungsjahrAusfuehren": "",
                 #"BaukontoBuchungsformular": "",
                 #"BaukontoSpendeBuchen": "",
                 #"BaukontoVorlageUebernehmen": "",
                 #"BaukontoMonatsbeitragBuchen": "",
                 #"BaukontoBuchungTesten": "",
                 #"BaukontoBuchungDurchfuehren": "",
                 #"LoeschenOhneStorno": "",
                 #"BaukontoGesamtliste": "",
                 #"BaukontoBuchungAnzeigen": "",
                 #"BaukontoVorlageAnzeigen": "",
                 #"BaukontoVorlageLoeschen": "",
                 #"BaukontoAlsVorlageSpeichern": "",
                 #"BaukontoVorlagenGesamtliste": "",
                 #"BaukontoStornoPruefen": "",
                 #"BaukontoBuchungStornieren": "",
                 #"BaukontoSpendenquittungDirektanzeige": "",
                 # Achtung, Test: Funktion "umgeleitet":
                 #"BaukontoSpendenquittungDirektanzeige": "",
                 #"BaukontoSpendenvorlagenAnzeigen": "",
                 #"BaukontoAuswahlSpeichern": "",
                 #"BaukontoSpendenquittungRegistrieren": "",
                 #"BaukontoSpendenquittungFehldruck": "",
                 #"BaukontoSollHabenAlle": "",
                 #"BaukontoSollHabenUnterkonten": "",
                 #"BaukontoSollHabenAlleHauptkonten": "",
                 #"KontoUebersichtAnzeigen": "",
                 #"KontoUebersichtAnzeigenGemeinden": "",
                 #"KontoUebersichtAnzeigenGrundstuecke": "",
                 #"BaukontoBelegnummerReport": "",
                 #"BaukontoEinzelspenderUebersicht": "",
                 #"BaukontoGesamtspendenUebersicht": "",
                 #"BaukontoSpendenquittungenUebersicht": "",
                 #"HauptkontoUebersichtAnzeigen": "",
                 #"GrundstueckeUebersichtAnzeigen": "",
                 #"GemeindekarteiAuswahlSpeichern": "",
                 #"GemeindekarteiSerienbriefAnzeigen": "",
                 #"GemeindekarteiAuswahlDruckliste": "",
                 #"GemeindekarteiSerienbriefDurchfuehren": "",
                 #"GemeindekarteiSerienbriefeDrucken": "",
                 #"GemeindekarteiSerienbriefDirektanzeige": "",
                 #"GemeindekarteiVorlagenAnzeigen": "",
                 "GemeindekarteiVorlageBearbeiten": "",
                 #"BaukontoSpendenquittungBearbeiten": "",
                 #"GemeindekarteiEmailRundschreibenAnzeigen": "",
                 #"GemeindekarteiEmailRundschreibenDurchfuehren": "",
                 #"GemeindekarteiVeraenderungen": "",
                 #"GemeindekarteiVeraenderungenDatensaetze": "",
                 #"GemeindekarteiEingabeformular": "",
                 "GemeindekarteiNeueintragBestaetigung": "",
                 #"GemeindekarteiSuchenDatensatzkurz": "",
                 #"GemeindekarteiNamensliste": "",
                 #"GemeindekarteiUngeprueftListe": "",
                 #"GemeindekarteiDruckliste": "",
                 #"GemeindekarteiAenderungsformular": "",
                 "GemeindekarteiNeuerEintragPruefen": "",
                 "GemeindekarteiAenderungenTesten": "",
                 "GemeindekarteiAenderungenDurchfuehren": "",
                 "GemeindekarteiLoeschenTesten": "",
                 "GemeindekarteiLoeschenBestaetigen": "",
                 "GemeindekarteiLoeschenDurchfuehren": "",
                 "GemeindekarteiNeuerEintragAnfang": "",
                 "GemeindekarteiKopierenDurchfuehren": ""}
                 #"GemeindekarteiGeburtstagslisteAusgabe": "",
                 #"GemeindekarteiKopierenTesten": "",
                 #"GemeindekarteiGeburtstagslisteAbfrage": ""}

# Die Buchfhrungsfunktionen drfen nur von Benutzern mit Berechtigung "b"
# aufgerufen werden.
                 

NUR_FIBU =       {"KontenplanUebersicht": "",
                 "KontoAnzeigen": "",
                 "KontenplanAenderungenTesten": "",
                 "KontenplanAenderungenDurchfuehren": "",
                 "KontoLoeschenPruefen": "",
                 "KontenplanLoeschenDurchfuehren": "",
                 "KontenplanNeuerEintragAnfang": "",
                 "KontenplanNeuerEintragDurchfuehren": "",
                 #"NeuesBuchungsjahrTesten": "",
                 #"NeuesBuchungsjahrAusfuehren": "",
                 "BaukontoBuchungsformular": "",
                 "BaukontoSpendeBuchen": "",
                 "BaukontoVorlageUebernehmen": "",
                 "BaukontoMonatsbeitragBuchen": "",
                 "BaukontoBuchungTesten": "",
                 "BaukontoBuchungDurchfuehren": "",
                 "LoeschenOhneStorno": "",
                 "BaukontoGesamtliste": "",
                 "BaukontoBuchungAnzeigen": "",
                 "BaukontoVorlageAnzeigen": "",
                 "BaukontoVorlageLoeschen": "",
                 "BaukontoAlsVorlageSpeichern": "",
                 "BaukontoVorlagenGesamtliste": "",
                 "BaukontoStornoPruefen": "",
                 "BaukontoBuchungStornieren": "",
                 #"BaukontoSpendenquittungDirektanzeige": "",
                 # Achtung, Test: Funktion "umgeleitet":
                 "BaukontoSpendenquittungDirektanzeige": "",
                 "BaukontoSpendenvorlagenAnzeigen": "",
                 "BaukontoAuswahlSpeichern": "",
                 "BaukontoSpendenquittungRegistrieren": "",
                 "BaukontoSpendenquittungFehldruck": "",
                 "BaukontoSollHabenAlle": "",
                 "BaukontoSollHabenUnterkonten": "",
                 "BaukontoSollHabenAlleHauptkonten": "",
                 "KontoUebersichtAnzeigen": "",
                 "KontoUebersichtAnzeigenGemeinden": "",
                 "KontoUebersichtAnzeigenGrundstuecke": "",
                 "BaukontoBelegnummerReport": "",
                 "BaukontoEinzelspenderUebersicht": "",
                 "BaukontoGesamtspendenUebersicht": "",
                 "BaukontoSpendenquittungenUebersicht": "",
                 "HauptkontoUebersichtAnzeigen": "",
                 "GrundstueckeUebersichtAnzeigen": "",
                 #"GemeindekarteiAuswahlSpeichern": "",
                 #"GemeindekarteiSerienbriefAnzeigen": "",
                 #"GemeindekarteiAuswahlDruckliste": "",
                 #"GemeindekarteiSerienbriefDurchfuehren": "",
                 #"GemeindekarteiSerienbriefeDrucken": "",
                 #"GemeindekarteiSerienbriefDirektanzeige": "",
                 #"GemeindekarteiVorlagenAnzeigen": "",
                 #"GemeindekarteiVorlageBearbeiten": "",
                 "BaukontoSpendenquittungBearbeiten": ""}

                 #"GemeindekarteiEmailRundschreibenAnzeigen": "",
                 #"GemeindekarteiEmailRundschreibenDurchfuehren": "",
                 #"GemeindekarteiVeraenderungen": "",
                 #"GemeindekarteiVeraenderungenDatensaetze": "",
                 #"GemeindekarteiEingabeformular": "",
                 #"GemeindekarteiNeueintragBestaetigung": "",
                 #"GemeindekarteiSuchenDatensatzkurz": "",
                 #"GemeindekarteiNamensliste": "",
                 #"GemeindekarteiUngeprueftListe": "",
                 #"GemeindekarteiDruckliste": "",
                 #"GemeindekarteiAenderungsformular": "",
                 #"GemeindekarteiNeuerEintragPruefen": "",
                 #"GemeindekarteiAenderungenTesten": "",
                 #"GemeindekarteiAenderungenDurchfuehren": "",
                 #"GemeindekarteiLoeschenTesten": "",
                 #"GemeindekarteiLoeschenBestaetigen": "",
                 #"GemeindekarteiLoeschenDurchfuehren": "",
                 #"GemeindekarteiNeuerEintragAnfang": "",
                 #"GemeindekarteiKopierenDurchfuehren": "",
                 #"GemeindekarteiGeburtstagslisteAusgabe": "",
                 #"GemeindekarteiKopierenTesten": "",
                 #"GemeindekarteiGeburtstagslisteAbfrage": ""}





