#coding: latin-1
#Ab Python2.3 ist die uncodierte Verwendung von Umlauten deprecated. 
import normalDate
import datumutilities
import textutilities
import htmlutilities
import textutilities
import sys
import re
import string
import sortieren
import urllib
import types
import optionen
import verschiedeneUtilities
import verwaltungMainServer
import gemeindeverwaltung

# Die bergeordnete Datei. Sie enthlt die Klassen und Funktionen
# die vom User-Interface aufgerufen werden. Ein CGI-Skript erzeugt
# z.B. jeweils adhoc eine Instanz z.B. von 

class GemeindeverwaltungWeb:
    # Die Hauptklasse fr alle "Web-Objekte", die in den CGI-Skripten
    # erzeugt werden
    # Ein Objekt wird vor allem durch ein "dictarray" initialisiert,
    # das eine Liste von einem oder mehreren Dictionaries enthlt.
    # Darin sind Datenstze enthalten, die jeweils z.B. ein Gemeindeglied
    # reprsentieren.
    def initReplace(self,wert):
        """Hier sollen alle bergebenen Werte z.B. aus MySQL usw. in HTML-konforme
        Darstellungen umgewandelt werden."""
        if wert == 0:
            return 0
        elif wert is None or wert == "" or wert == "None":
            wert = "-"
        return wert

    
    def __init__(self,dictarray,schaltzentrale,alleSpalten,schluessel="",datumumwandeln="ja"):
        # "alleSpalten" soll aus Konsistenzgrnden immer bergeben werden.
        self.dummyflag=0
        try:
            self.dictlaenge = len(dictarray)           
        except:           
            self.dummyflag=1
        try:
            if not dictarray[0]:
                # Zusatztest, wenn der Dictarray als erstes Element z.B. nur ein leeres Tupel enthlt
                # Mu in einen eigenen try/except-Block, weil z.B. beim aenderungsvergleich kein wirklicher
                # dictarray, sondern ein einzelner Dict bergeben wird.
                self.dummyflag=1
        except:
            pass
        if self.dummyflag:
            # ein "Dummy-Dictarray", wenn - etwa als Ergebnis einer milungenen Abfrage -
            # nichts "Gescheites" bergeben wurde.
            tempdict = {}
            for i in alleSpalten:
                tempdict[i] = ""
            dictarray = [tempdict]
            self.dictlaenge = len(dictarray)
        self.htmlwerkzeug = htmlutilities.HtmlUtilities()
        self.datumwerkzeug = datumutilities.Datum()
        self.sortierwerkzeug = sortieren.Sortieren()
        self.textwerkzeug = textutilities.Textutilities()
        self.datum_mysql = re.compile(r"((\d\d\d\d)-(\d\d)-(\d\d))")
        if datumumwandeln == "ja":
            self.dictarray = self.sortierwerkzeug.mapAll(dictarray,funktion=self.mysqlDatumUmwandeln,nichtaendern = ['Fax','EMail','Telefon','Belegnummer'])
        self.dictarray = self.sortierwerkzeug.mapAll(self.dictarray,funktion=self.initReplace)
       
        self.schaltzentrale = schaltzentrale
        self.schluessel = schluessel
        # ***** Achtung, darf keine Spaces enthalten!
        self.alleSpalten = alleSpalten

    def mysqlDatumUmwandeln(self,wert):
        """Wandelt das Datumsformat von MySQL in ein bliches
        deutsches Format um"""
        wert = "%s" % wert
        # *** Umwandlung in String, wichtig, weil der Primrschlssel Integer ist! ***
        mobj = self.datum_mysql.search(wert)
        if mobj is not None:
            return mobj.group(4)+"."+mobj.group(3)+"."+mobj.group(2)
        else:
            return wert

    def datumswertUmwandeln(self,wert):
        if type(wert) is type(self.datumwerkzeug):
            return wert.mysqlFormat()
        else:
            return wert

    def aufOptionsfelderPruefen(self,kategorie,wert,optionsdict):
        # wenn fr eine Kategorie Auswahlfelder vorgesehen sind
        if kategorie in optionsdict.keys():
            # Das folgende Schema wird von der Formularfunktion in htmlutilities erkannt:
            return ['Optionen',kategorie,optionsdict[kategorie],wert]
        else:
            return [kategorie,wert]

    def aenderungsformular(self,optionsfelder,aktion,skript,submit,submit2="",optionscheck="ja"):
        datenlist = []        
        for i in self.alleSpalten:
            feld = self.aufOptionsfelderPruefen(i,self.dictarray[0][i],optionsfelder)
            datenlist.append(feld)
        return self.htmlwerkzeug.eingabeFormularAusgeben(datenlist,hidden=(('Aktion',aktion),('schluessel',self.schluessel)),skript=skript,submit=submit,submit2=submit2) 


    def aenderungsvergleich(self,bestaetigen_link,zurueck_link):
        matrix = []
        matrix.append(["<b>Kategorie</b>","<b>alt</b>","<b>neu/gendert</b>"])
        for i in self.dictarray.keys():
            matrix.append([i,self.datumswertUmwandeln(self.dictarray[i][0]),self.dictarray[i][1]])  
        print "<H3>Folgende Neueintrge/nderungen werden durchgefhrt:</H3>"
        print self.htmlwerkzeug.tabelleMitInhalt(matrix)
        print "<br>"
        # *******************************************************
        smartlink = """
        <a href = "%s?Aktion=%s&schluessel=%s%s">Neueintrge/nderungen besttigen</a> 
        """
        # Der smartlink knnte auch hier mit htmlutilities erzeugt werden...
        anhang = ""
        del matrix[0]
        # berschriften der Tabelle entfernen (Kategorie,alt,gendert), dann
        # Verwandlung von matrix zur bertragung in der URL von smartlink:
        for i in matrix:
            wert = urllib.quote_plus(i[2])
            kategorie = i[0]
            anhang += """&%s=%s""" % (kategorie,wert)
        print "<p>",smartlink  % (self.schaltzentrale,bestaetigen_link,self.schluessel,anhang)
        # *******************************************************
        print "<p>"
        print """<a href = "%s?Aktion=%s&schluessel=%s"><H3>Rckgngig!</H3></a>""" % (self.schaltzentrale,zurueck_link,self.schluessel)


    def datensatzkurztabelle(self,kategorien,fontsize="-1"):
        """Gibt eine zu druckende Tabelle aus."""       
        liste = [ ]
        liste.append(kategorien)
        for datensatz in self.dictarray:
            templist = [ ]
            for j in kategorien:
                # leere Felder fllen fr Netscape, Abstand zur nchsten Zelle
                datensatz[j] += "&nbsp;&nbsp;"
                templist.append(datensatz[j])
            liste.append(templist)
        return self.htmlwerkzeug.tabelleMitInhalt(liste,border="1",weite="100%",fontsize=fontsize)

    def tabelleErstesElement(self,border="0",weite="100%",fontsize="-1",cellpadding="0",cellspacing="0",aufspalten="nein",nummer=0):
        matrix = []
        for key in self.alleSpalten:
            matrix.append(["<b>%s</b>"%key,self.dictarray[nummer][key]])
        return self.htmlwerkzeug.tabelleMitInhalt(matrix,border=border,weite=weite,fontsize=fontsize,cellpadding=cellpadding,cellspacing=cellspacing,aufspalten=aufspalten)

class GemeindekarteiWebNormal(GemeindeverwaltungWeb):
    
    def __init__(self,MysqlDatenbank,Buchungsjahr,dictarray=[],schaltzentrale="",alleSpalten=[],schluessel="",datumumwandeln="ja"):
        self.primaerkartei = "MZ"
        # ist hier Instanzvariable, nicht global, weil GemeindekarteiWeb nicht - wie die anderen Web-Klassen -
        # in einer eigenen Datei wohnt...
        self.optionswerkzeug = optionen.Optionen(MysqlDatenbank,buchungsjahr=Buchungsjahr)
        self.optionsfelder = self.optionswerkzeug.gemeindekartei_optionsfelder()
        self.MysqlDatenbank, self.Buchungsjahr = MysqlDatenbank, Buchungsjahr
        GemeindeverwaltungWeb.__init__(self,dictarray,schaltzentrale,alleSpalten,schluessel)

 ##   def loeschenAbfrage(self):
##        print """<body bgcolor="#FFEE00">"""
##        print "<H3>Der folgende Eintrag wird endgltig gelscht:</H3>"
##        self.datensatzkurz(deutschesDatum="ja")
##        i = self.dictarray[0]
##        smartlink = self.htmlwerkzeug.smartlink(self.schaltzentrale,{'schluessel':i[self.primaerkartei],'Aktion':'GemeindekarteiLoeschenBestaetigen'},"Endgltig lschen!")
##        print """<p><H3>%s</H3>""" % smartlink

    def loeschenAbfrage(self):
        print """<body bgcolor="#FF1100" >"""
        print "<H3>Der folgende Eintrag wird endgltig gelscht:</H3>"
        self.datensatzkurz(deutschesDatum="ja")
        i = self.dictarray[0]
        smartlink = self.htmlwerkzeug.smartlink(self.schaltzentrale,{'schluessel':i[self.primaerkartei],'Aktion':'GemeindekarteiLoeschenDurchfuehren'},"Endgltiges Lschen besttigen!")
        print """<p><H3>%s</H3>""" % smartlink

    def datensatzkurztabelle(self,kategorien=['Nachname','Vorname','Strasse','Postleitzahl','Wohnort','Geburtstag','Telefon','Kirchenbuch']):
        """Gibt eine zu druckende Tabelle der Gemeindekartei aus, wie man
        sie sonst immer schriftlich mit sich fhrt."""
        return GemeindeverwaltungWeb.datensatzkurztabelle(self,kategorien,fontsize="-2")
       

    def datensatzkurz(self,deutschesDatum="nein",Aktion="GemeindekarteiAuswahlSpeichern"):
        # print "<H3>%s gefundene Eintrge in der Gemeindekartei:</H3>" % self.dictlaenge
        if self.dummyflag:
            # Ein Patch, weil diese Funktion nicht mit dem Dummy-Dict zurechtkommt.
            # *** TODO: Die Funktion ist ohnehin noch zu ndern - sie soll den HTML-Text nicht printen,
            # sondern als String zurckgeben, wie die anderen Web-Funktionen auch.
            print """<H3>Kein Datensatz vorhanden!</H3>"""
            # verschiedeneUtilities.gibLaut("Fehler")
            return 0
        geburtstag=""       
        # *****************
        datensatz_html = """
        <font size=-1>
        <b>
        %s, %s (%s)  &nbsp;&nbsp; <input type = "checkbox" name = "MZ%s" checked = "checked" />
        <i>&nbsp;&nbsp;&nbsp;&nbsp; %s</i>  </b>
        <br> %s, %s, geb.: %s  
        <br>Telefon: %s 
        <br>
        %s &nbsp;&nbsp; &nbsp;&nbsp;%s &nbsp;&nbsp;&nbsp;&nbsp;%s  &nbsp;&nbsp;&nbsp;&nbsp;<i>%s</i>  &nbsp;&nbsp;&nbsp;&nbsp;%s &nbsp;&nbsp;&nbsp;&nbsp;<b>%s </b> 
       
        </font>
        <p>
        """
        string1 = """<form action = %s %s>""" % (self.schaltzentrale,verwaltungMainServer.POST)
        geprueft = ""
        for i in self.dictarray:
            geburtstag = i['Geburtstag']     
            smartlink1 = self.htmlwerkzeug.smartlink(self.schaltzentrale,{'schluessel':i[self.primaerkartei],'Aktion':'GemeindekarteiAenderungsformular'},"Alles/ndern")
            smartlink2 =  self.htmlwerkzeug.smartlink(self.schaltzentrale,{'schluessel':i[self.primaerkartei],'Aktion':'GemeindekarteiKopierenTesten'},"Eintrag kopieren")
            smartlink3 =  self.htmlwerkzeug.smartlink(self.schaltzentrale,{'schluessel':i[self.primaerkartei],'Aktion':'BaukontoSpendeBuchen'},"Spende")
            smartlinkMonatsbeitrag = self.htmlwerkzeug.smartlink(self.schaltzentrale,{'schluessel':i[self.primaerkartei],'Aktion':'BaukontoMonatsbeitragBuchen'},"Monatsbeitrag")
            if i['geprueft'] == "nein":
                # Nur ungeprfte Eintrge knnen gelscht werden:
                smartlink4 =  self.htmlwerkzeug.smartlink(self.schaltzentrale,{'schluessel':i[self.primaerkartei],'Aktion':'GemeindekarteiLoeschenTesten'},"lschen!")
                geprueft = "ungeprfter Eintrag!"
            else:
                smartlink4 = ""
                geprueft = ""
            smartlink5 = self.htmlwerkzeug.smartlink(self.schaltzentrale,{'schluessel':i[self.primaerkartei],'Aktion':'BaukontoEinzelspenderUebersicht'},"Spendenbersicht")
            string1 += datensatz_html % (i['Nachname'],i['Vorname'],i['Kirchenbuch'],i['MZ'],geprueft,i['Strasse'],i['Wohnort'],geburtstag,i['Telefon'],smartlink1,smartlink3,smartlinkMonatsbeitrag,smartlink5,smartlink2,smartlink4)
            # gendert: kein Datum-Typ verwendet
        string1 += """<H4>Speichern Sie die Auswahl fr Serienbriefe, E-Mail-Rundschreiben u.a. Deaktivieren Sie ggf. vorher die Hkchen bei nicht gebrauchten Datenstzen:</H4>"""
        string1 += """<input type = "submit" name = "submitbutton" value = "Auswahl speichern"/>
        <input type = "hidden" name = "Aktion" value = "%s" />
        </form>""" % Aktion
        print """<H3>Gesamtzahl: %s</H3><p>""" % len(self.dictarray)
        print string1
        # verschiedeneUtilities.gibLaut("Besttigung")
    

    def aenderungsformular(self,aktion="GemeindekarteiAenderungenTesten",mitLinks="ja"):
        temp = GemeindeverwaltungWeb.aenderungsformular(self,optionsfelder=self.optionsfelder,aktion=aktion,skript=self.schaltzentrale,submit="Neueintrge/nderungen prfen")
        smartlink1 = self.htmlwerkzeug.smartlink(self.schaltzentrale,{'MZ': self.dictarray[0]["MZ"],'Aktion': 'GemeindekarteiAuswahlSpeichern'},"""FormularDirekt""")
        smartlink2 =  self.htmlwerkzeug.smartlink(self.schaltzentrale,{'schluessel': self.dictarray[0]["MZ"],'Aktion': 'ZuordnungNeuerEintragAnfang'},"""Zuordnung""")
	if mitLinks == "ja":
	    return temp + "<p>" + smartlink1 + "&nbsp;&nbsp;" + smartlink2
	else:
	    return temp

    def geburtstagslistenformular(self,aktion="GemeindekarteiGeburtstagslisteAusgabe",optionen = {"nur KG, KA": ("ja","nein"), "Anrede_verwenden": ("ja","nein")}):
        
        return GemeindeverwaltungWeb.aenderungsformular(self,optionsfelder=optionen,aktion=aktion,skript=self.schaltzentrale,submit="Anzeigen")
    

    def eingabeformular(self,dict={"Status": "Kirchen*","abgegangen": "nein"}):
        # sucht standardmig nach nicht abgegangenen
        # Gemeindegliedern
        liste = []        
        for i in self.alleSpalten:
            liste.append([i,dict.get(i,"")])            
        return  self.htmlwerkzeug.eingabeFormularAusgeben(liste,self.schaltzentrale,hidden=(('Aktion','GemeindekarteiSuchenDatensatzkurz'),),submit='Suchen')
                          
    def aenderungsvergleich(self,neueintrag="nein"):
        """berschreibt die entsprechende Funktion in der Superklasse. Beachte die
        andere Art und Anzahl der Funktionsparameter!"""
        zurueck_link = ""
        bestaetigen_link = "GemeindekarteiAenderungenDurchfuehren"
        if neueintrag == "ja":
            zurueck_link = "GemeindekarteiLoeschenDurchfuehren"
        else:
            zurueck_link = "GemeindekarteiAenderungsformular"
        return GemeindeverwaltungWeb.aenderungsvergleich(self,bestaetigen_link,zurueck_link)

    def karteiaenderungen(self,zugangsdict,abgangsdict,statusuebersicht):
        rueckgabe = """<H3>Alle Vernderungen in der Gemeindekartei, Datenbank %s, Jahr %s</H3>""" % (self.optionswerkzeug.Datenbankname, self.optionswerkzeug.buchungsjahr)
        # rueckgabe += """<H4>Bitte berprfen Sie fr jeden Status, ob sich dort Fehleintrge mit Zugangs- oder Abgangsgrund = "-" befinden.</H4>"""
        Statustupel = list(self.optionsfelder["Status"])
        if not (Statustupel[0][0] in string.letters):
            Statustupel = Statustupel[1:] + [Statustupel[0]]
            # Wenn der erste Status kein Wort ist, das mit einem Buchstaben beginnt, z.B. "-"
        # Statustupel.sort()
        Abgangsgruende = self.optionsfelder["Abgangsgrund"]
        Zugangsgruende = self.optionsfelder["Zugangsgrund"]
        for status in Statustupel:
            zusatz = ""
            if status == "-":
                zusatz = """Anzeige des folgenden "Status" zur berprfung auf Fehleintrge - <br>hier mte alles auf "-" stehen! =><br> """
            rueckgabe += """<H4>%sAlle Vernderungen fr Status "%s": </H4>""" % (zusatz,status)
            tempmatrix = []
            for grund in Zugangsgruende:
                smartlink = self.htmlwerkzeug.smartlink(self.schaltzentrale,{'Veraenderung': 'Zugang','Status': status, 'Grund': grund ,'Aktion': 'GemeindekarteiVeraenderungenDatensaetze'},"""Zugang durch "%s" """% grund)
                tempmatrix.append([smartlink,"&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<b>%s</b>" % zugangsdict[status][grund]["Lnge"]])
            tempmatrix.append(["&nbsp;", "&nbsp;"]) # Leerzeile
            for grund in Abgangsgruende:
                smartlink = self.htmlwerkzeug.smartlink(self.schaltzentrale,{'Veraenderung': 'Abgang','Status': status, 'Grund': grund ,'Aktion': 'GemeindekarteiVeraenderungenDatensaetze'},"""Abgang durch "%s" """% grund)
                tempmatrix.append([smartlink,"&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<b>%s</b>" % abgangsdict[status][grund]["Lnge"]])
            tempmatrix.append(["&nbsp;", "&nbsp;"]) # Leerzeile
            smartlink = self.htmlwerkzeug.smartlink(self.schaltzentrale,{'Status': status, 'abgegangen': "nein" ,'Aktion': 'GemeindekarteiSuchenDatensatzkurz'},"Gesamtzahl am %s: " % self.datumwerkzeug.deutschesFormat())
            tempmatrix.append(["""<b>%s</b>""" % smartlink, "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<b>%s</b>" % statusuebersicht[status]])
            rueckgabe += self.htmlwerkzeug.tabelleMitInhalt(tempmatrix,border="1",weite="40%")
            # rueckgabe += """<b>Aktuelle Gesamtzahl fr Status "%s": %s</b>""" % (status,statusuebersicht[status])
        return rueckgabe

class GemeindekarteiWebEmkAdressen(GemeindekarteiWebNormal):
      def __init__(self,MysqlDatenbank,Buchungsjahr,dictarray=[],schaltzentrale="",alleSpalten=[],schluessel="",datumumwandeln="ja"):
          return GemeindekarteiWebNormal.__init__(self,MysqlDatenbank=MysqlDatenbank,Buchungsjahr=Buchungsjahr,dictarray=dictarray,schaltzentrale=schaltzentrale,alleSpalten=alleSpalten,schluessel=schluessel,datumumwandeln=datumumwandeln)

      def datensatzkurztabelle(self,kategorien=['Nachname','Vorname','Konferenz','EMail','Strasse','Postleitzahl','Wohnort','Telefon']):
        """Gibt eine zu druckende Tabelle der Gemeindekartei aus, wie man
        sie sonst immer schriftlich mit sich fhrt."""
        return GemeindeverwaltungWeb.datensatzkurztabelle(self,kategorien,fontsize="-2")       

      def datensatzkurz(self,deutschesDatum="nein",Aktion="GemeindekarteiAuswahlSpeichern"):
        # print "<H3>%s gefundene Eintrge in der Gemeindekartei:</H3>" % self.dictlaenge
        gemeindekartei = gemeindeverwaltung.GemeindekarteiBearbeiten(self.MysqlDatenbank,self.Buchungsjahr)
        if self.dummyflag:
            # Ein Patch, weil diese Funktion nicht mit dem Dummy-Dict zurechtkommt.
            # *** TODO: Die Funktion ist ohnehin noch zu ndern - sie soll den HTML-Text nicht printen,
            # sondern als String zurckgeben, wie die anderen Web-Funktionen auch.
            print """<H3>Kein Datensatz vorhanden!</H3>"""
            # verschiedeneUtilities.gibLaut("Fehler")
            return 0     
        # *****************
        datensatz_html = """
        <font size=-1>
        <b>
        %s, %s (%s, %s)  &nbsp;&nbsp; <input type = "checkbox" name = "MZ%s" checked = "checked" />
        <i>&nbsp;&nbsp;&nbsp;&nbsp; %s</i>  </b>
        <br> %s, %s %s  
        <br>Telefon: %s 
        <br>
        %s &nbsp;&nbsp; %s &nbsp;&nbsp; %s &nbsp;&nbsp;<b>%s </b> 
       
        </font>
        <p>
        """
        string1 = """<form action = %s %s>""" % (self.schaltzentrale,verwaltungMainServer.POST)
        geprueft = ""
        for i in self.dictarray:   
            smartlink1 = self.htmlwerkzeug.smartlink(self.schaltzentrale,{'schluessel':i[self.primaerkartei],'Aktion':'GemeindekarteiAenderungsformular'},"Alles/ndern")
            smartlink2 = self.htmlwerkzeug.smartlink(self.schaltzentrale,{'schluessel':i[self.primaerkartei],'Aktion':'ZuordnungUebersicht'},"Zuordnung anzeigen")
            smartlink3 = self.htmlwerkzeug.smartlink(self.schaltzentrale,{'schluessel':i[self.primaerkartei],'Aktion':'ZuordnungNeuerEintragAnfang'},"Zuordnung herstellen")
            if i['geprueft'] == "nein":
                # Nur ungeprfte Eintrge knnen gelscht werden:
                smartlink4 =  self.htmlwerkzeug.smartlink(self.schaltzentrale,{'schluessel':i[self.primaerkartei],'Aktion':'GemeindekarteiLoeschenTesten'},"lschen!")
                geprueft = "ungeprfter Eintrag!"
            else:
                smartlink4 = ""
                geprueft = ""
            # Achtung, Test: Status -> Status1, Postleitzahl -> PLZ, Wohnort -> Ort, Nachname -> Name
            status = gemeindekartei.abkuerzungBedeutung(i["Status"]) 
            string1 += datensatz_html % (i['Nachname'],i['Vorname'],i['Konferenz'],status,i['MZ'],geprueft,i['Strasse'],i['Postleitzahl'],i['Wohnort'],i['Telefon'],smartlink1,smartlink2,smartlink3,smartlink4)
            # gendert: kein Datum-Typ verwendet
        temp1 = """<H4>Speichern Sie die Auswahl fr Serienbriefe, E-Mail-Rundschreiben u.a. Deaktivieren Sie ggf. vorher die Hkchen bei nicht gebrauchten Datenstzen (Schaltflche ganz unten):</H4>""" 
        temp2 = """<input type = "submit" name = "submitbutton" value = "Auswahl speichern"/>
        <input type = "hidden" name = "Aktion" value = "%s" />
        </form>""" % Aktion
        print """<H3>Gesamtzahl: %s</H3><p>""" % len(self.dictarray)
        string1 = temp1 + "<p>"+ string1 + temp2
        print string1
        # verschiedeneUtilities.gibLaut("Besttigung")

      def datensatzBezirke(self,dictarray):
          """In dictarray befinden sich in jeder Zeile zwei Eintrge: {"Bezirk": ..., "Personen": dictarray aller Personen}"""
          matrix = [["<H4>Bezirk</H4>","<H4>Personen</H4>"]]
          try:
              for i in dictarray:
                  if not i:
                      continue
                  tempmatrix = [i["Bezirk"]]
                  temptext = "   "
                  for j in i["Personen"]:
                      if j != ():
                         #temptext += "%s, " % self.htmlwerkzeug.smartlink(self.schaltzentrale,{'schluessel': "eins",'Aktion': 'GemeindekarteiAenderungsformular'}, "zwei")              
                         name = "%s %s (%s)" % (j["Vorname"],j["Nachname"],j["Status"])
                         temptext += """%s, """ % self.htmlwerkzeug.smartlink(self.schaltzentrale,{'schluessel': "%s" % j["MZ"],'Aktion': 'GemeindekarteiAenderungsformular'}, name)
                  tempmatrix.append(temptext[:-2])
                  matrix.append(tempmatrix)
          except:
              pass # fr falsche / fehlende Eintrge              
          return self.htmlwerkzeug.tabelleMitInhalt(matrix,border="1")  

class GemeindekarteiWebEmkAdressen_Neu(GemeindekarteiWebEmkAdressen):
      def __init__(self,MysqlDatenbank,Buchungsjahr,dictarray=[],schaltzentrale="",alleSpalten=[],schluessel="",datumumwandeln="ja"):
          return GemeindekarteiWebEmkAdressen.__init__(self,MysqlDatenbank=MysqlDatenbank,Buchungsjahr=Buchungsjahr,dictarray=dictarray,schaltzentrale=schaltzentrale,alleSpalten=alleSpalten,schluessel=schluessel,datumumwandeln=datumumwandeln)

      def abkuerzungenUmwandeln(self):
          for d in self.dictarray:
              for s in ("Status1","Status2","Status3","Status4","Status5"):                  
                  temp = self.optionswerkzeug.status.get(d[s],"-")
                  d[s] = "%s: %s" % (d[s], temp.get("b","-"))
              d["Distrikt"] = "%s: %s" % (d["Distrikt"],self.optionswerkzeug.distrikte.get(d["Distrikt"],"-"))

      def aenderungsformular(self,aktion="GemeindekarteiAenderungenTesten",mitLinks="ja"):
          self.abkuerzungenUmwandeln()
          return GemeindekarteiWebNormal.aenderungsformular(self,aktion=aktion,mitLinks=mitLinks)
                                     
      def datensatzkurztabelle(self,kategorien=['Name','Vorname','Konferenz','Mail','Strasse','PLZ','Ort','Telefon']):
        """Gibt eine zu druckende Tabelle der Gemeindekartei aus, wie man
        sie sonst immer schriftlich mit sich fhrt."""
        return GemeindeverwaltungWeb.datensatzkurztabelle(self,kategorien,fontsize="-2")       

      def datensatzkurz(self,deutschesDatum="nein",Aktion="GemeindekarteiAuswahlSpeichern"):
        # print "<H3>%s gefundene Eintrge in der Gemeindekartei:</H3>" % self.dictlaenge
        gemeindekartei = gemeindeverwaltung.GemeindekarteiBearbeiten(self.MysqlDatenbank,self.Buchungsjahr)
        if self.dummyflag:
            # Ein Patch, weil diese Funktion nicht mit dem Dummy-Dict zurechtkommt.
            # *** TODO: Die Funktion ist ohnehin noch zu ndern - sie soll den HTML-Text nicht printen,
            # sondern als String zurckgeben, wie die anderen Web-Funktionen auch.
            print """<H3>Kein Datensatz vorhanden!</H3>"""
            # verschiedeneUtilities.gibLaut("Fehler")
            return 0     
        # *****************
        datensatz_html = """
        <font size=-1>
        <b>
        %s, %s (%s: %s)  &nbsp;&nbsp; <input type = "checkbox" name = "MZ%s" checked = "checked" />
        <i>&nbsp;&nbsp;&nbsp;&nbsp; %s</i>  </b>
        <br> %s, %s %s  
        <br>Telefon: %s 
        <br>
        %s &nbsp;&nbsp; %s &nbsp;&nbsp; %s &nbsp;&nbsp;<b>%s </b> 
       
        </font>
        <p>
        """
        string1 = """<form action = %s %s>""" % (self.schaltzentrale,verwaltungMainServer.POST)
        geprueft = ""
        neudictarray = self.textwerkzeug.privatStattDienstlichDictarray(self.dictarray)
        for i in neudictarray:   
            smartlink1 = self.htmlwerkzeug.smartlink(self.schaltzentrale,{'schluessel':i[self.primaerkartei],'Aktion':'GemeindekarteiAenderungsformular'},"Alles/ndern")
            smartlink2 = self.htmlwerkzeug.smartlink(self.schaltzentrale,{'schluessel':i[self.primaerkartei],'Aktion':'ZuordnungUebersicht'},"Zuordnung anzeigen")
            smartlink3 = self.htmlwerkzeug.smartlink(self.schaltzentrale,{'schluessel':i[self.primaerkartei],'Aktion':'ZuordnungNeuerEintragAnfang'},"Zuordnung herstellen")
            if i['geprueft'] == "nein":
                # Nur ungeprfte Eintrge knnen gelscht werden:
                smartlink4 =  self.htmlwerkzeug.smartlink(self.schaltzentrale,{'schluessel':i[self.primaerkartei],'Aktion':'GemeindekarteiLoeschenTesten'},"lschen!")
                geprueft = "ungeprfter Eintrag!"
            else:
                smartlink4 = ""
                geprueft = ""
            status = gemeindekartei.statusZusammenfassung(i)
            string1 += datensatz_html % (i['Name'],i['Vorname'],i['Konferenz'],status,i['MZ'],geprueft,i['Strasse'],i['PLZ'],i['Ort'],i['Telefon'],smartlink1,smartlink2,smartlink3,smartlink4)
            # gendert: kein Datum-Typ verwendet
        temp1 = """<H4>Speichern Sie die Auswahl fr Serienbriefe, E-Mail-Rundschreiben u.a. Deaktivieren Sie ggf. vorher die Hkchen bei nicht gebrauchten Datenstzen (Schaltflche ganz unten):</H4>""" 
        temp2 = """<input type = "submit" name = "submitbutton" value = "Auswahl speichern"/>
        <input type = "hidden" name = "Aktion" value = "%s" />
        </form>""" % Aktion
        print """<H3>Gesamtzahl: %s</H3><p>""" % len(self.dictarray)
        string1 = temp1 + "<p>"+ string1 + temp2
        print string1
        # verschiedeneUtilities.gibLaut("Besttigung")

      def datensatzBezirke(self,dictarray):
          """In dictarray befinden sich in jeder Zeile zwei Eintrge: {"Bezirk": ..., "Personen": dictarray aller Personen}"""
          matrix = [["<H4>Bezirk</H4>","<H4>Personen</H4>"]]
          try:
              for i in dictarray:
                  if not i:
                      continue
                  tempmatrix = [i["Bezirk"]]
                  temptext = "   "
                  for j in i["Personen"]:
                      if j != ():
                         #temptext += "%s, " % self.htmlwerkzeug.smartlink(self.schaltzentrale,{'schluessel': "eins",'Aktion': 'GemeindekarteiAenderungsformular'}, "zwei")              
                         name = "%s %s (%s)" % (j["Vorname"],j["Name"],j["Status1"])
                         temptext += """%s, """ % self.htmlwerkzeug.smartlink(self.schaltzentrale,{'schluessel': "%s" % j["MZ"],'Aktion': 'GemeindekarteiAenderungsformular'}, name)
                  tempmatrix.append(temptext[:-2])
                  matrix.append(tempmatrix)
          except:
              pass # fr falsche / fehlende Eintrge              
          return self.htmlwerkzeug.tabelleMitInhalt(matrix,border="1") 


def GemeindekarteiWeb(MysqlDatenbank,Buchungsjahr,dictarray=[],schaltzentrale="",alleSpalten=[],schluessel="",datumumwandeln="ja"):
    """Factory-Funktion fr die Geschmacksrichtungen."""
    kirche = verschiedeneUtilities.geschmacksrichtung(MysqlDatenbank)    
    if kirche in ("metho","evang","kath"):
        return GemeindekarteiWebNormal(MysqlDatenbank=MysqlDatenbank,Buchungsjahr=Buchungsjahr,dictarray=dictarray,schaltzentrale=schaltzentrale,alleSpalten=alleSpalten,schluessel=schluessel,datumumwandeln=datumumwandeln)
    if kirche == "emkadressen":
        return GemeindekarteiWebEmkAdressen(MysqlDatenbank=MysqlDatenbank,Buchungsjahr=Buchungsjahr,dictarray=dictarray,schaltzentrale=schaltzentrale,alleSpalten=alleSpalten,schluessel=schluessel,datumumwandeln=datumumwandeln)
    if kirche == "emkadressen_neu":
        return GemeindekarteiWebEmkAdressen_Neu(MysqlDatenbank=MysqlDatenbank,Buchungsjahr=Buchungsjahr,dictarray=dictarray,schaltzentrale=schaltzentrale,alleSpalten=alleSpalten,schluessel=schluessel,datumumwandeln=datumumwandeln)

        
        
