#!/usr/local/bin/python2.3
#coding: latin-1
#Ab Python2.3 ist die uncodierte Verwendung von Umlauten deprecated.

# ********* Hauptprogramm fr die Gemeindeverwaltung *********
#
# Diese Datei ist die "Schaltzentrale" fr alle Cgi-Anwendungen.
# Sie bernimmt die Daten mit cgi.FieldStorage(), das "Aktion"-Flag
# sorgt fr die richtigen Aufrufe.
# Aller HTML-Code wird von den aufgerufenen Objekten wie "Aenderungsformular"
# erzeugt. Diese Objekte sind alle Ableitungen von GemeindeverwaltungWeb.
#
# ************************************************************
#

execfile("config.py") # Ausfhren, weil es bedingte Konstanten enthlt
from config import *


# Die Importe erst hier, weil einige Module die o.g. Konfigurationsvariablen voraussetzen:
import streamredirect
import MySQLdb
import MySQLdb.converters
import sys
import gemeindeverwaltung
import htmlutilities
import string
import datumutilities
import cgi
import urllib
import Cookie
import os
import gemeindekarteiweb
import baukontoweb
import optionenweb
import optionen
import re
import verwaltungMainUtilities
import statemysql
import state
import time
import kontenplan
import kontenplanweb
import update
# import gesangbuchweb
import abkuerzungenweb
import zuordnungenweb
import verschiedeneUtilities
import md5
import verwaltungMainOptionen
import verwaltungMainAbkuerzungen
import verwaltungMainKontenplan
import verwaltungMainFibu
import verwaltungMainFibuStatistik
import verwaltungMainGemeindekarteiSerienbriefe
import verwaltungMainGemeindekartei
import verwaltungMainZuordnungen

import baukontomysql
import gemeindekarteimysql
import zuordnungenmysql
# diese Imports fr die bertragung an eine globale Variable - schlechter Stil...

# funktionsdict enthlt den Ort (fast) aller Cgi-Funktionen.
funktionsdict = {"OptionenAenderungsformular": verwaltungMainOptionen,
                 "OptionenAenderungenTesten": verwaltungMainOptionen,
                 "OptionenAenderungenDurchfuehren": verwaltungMainOptionen,
                 "SelectBefehlDirektEingabe": verwaltungMainOptionen,
                 "NeueDatenbankTesten": verwaltungMainOptionen,
                 "NeueDatenbankAusfuehren": verwaltungMainOptionen,
                 "KopieDatenbankTesten": verwaltungMainOptionen,
                 "KopieDatenbankAusfuehren": verwaltungMainOptionen,
                 "UpdateInfoAnzeigen": verwaltungMainOptionen,
                 "UpdateStarten": verwaltungMainOptionen,
                 "GemeindekarteiRuecksichernAnzeigen": verwaltungMainOptionen,
                 "GemeindekarteiRuecksichernDurchfuehren": verwaltungMainOptionen,
                 "GemeindekarteiExportieren": verwaltungMainOptionen,
                 "GemeindekarteiExportierenDurchfuehren": verwaltungMainOptionen,
                 "AuswahlExportieren": verwaltungMainOptionen,
                 "AuswahlExportierenDurchfuehren": verwaltungMainOptionen,
                 "SelectBefehlDirektAusfuehren": verwaltungMainOptionen,
                 "GemeindekarteiImportierenTesten": verwaltungMainOptionen,
                 "GemeindekarteiImportierenDurchfuehren": verwaltungMainOptionen,
                 "DatenSichern": verwaltungMainOptionen,
                 "AbkuerzungEingabeformular": verwaltungMainAbkuerzungen,
                 "AbkuerzungAenderungsformular": verwaltungMainAbkuerzungen,
                 "AbkuerzungAenderungenTesten": verwaltungMainAbkuerzungen,
                 "AbkuerzungAenderungenDurchfuehren": verwaltungMainAbkuerzungen,
                 "AbkuerzungLoeschenPruefen": verwaltungMainAbkuerzungen,
                 "AbkuerzungLoeschenDurchfuehren": verwaltungMainAbkuerzungen,
                 "AbkuerzungNeuerEintragAnfang": verwaltungMainAbkuerzungen,
                 "AbkuerzungNeuerEintragDurchfuehren": verwaltungMainAbkuerzungen,
                 "AbkuerzungUebersicht": verwaltungMainAbkuerzungen,                 
                 "ZuordnungEingabeformular": verwaltungMainZuordnungen,
                 "ZuordnungAenderungsformular": verwaltungMainZuordnungen,
                 "ZuordnungAenderungenTesten": verwaltungMainZuordnungen,
                 "ZuordnungAenderungenDurchfuehren": verwaltungMainZuordnungen,
                 "ZuordnungLoeschenPruefen": verwaltungMainZuordnungen,
                 "ZuordnungLoeschenDurchfuehren": verwaltungMainZuordnungen,
                 "ZuordnungNeuerEintragAnfang": verwaltungMainZuordnungen,
                 "ZuordnungNeuerEintragDurchfuehren": verwaltungMainZuordnungen,
                 "ZuordnungUebersicht": verwaltungMainZuordnungen,
                 "ZuordnungEinzel": verwaltungMainZuordnungen,
                 "ZuordnungAdressenBank": verwaltungMainZuordnungen,
                 "ZuordnungAdresseBankAenderungsformular": verwaltungMainZuordnungen,
                 "ZuordnungAdresseGeaendert": verwaltungMainZuordnungen,
                 "ZuordnungBankGeaendert": verwaltungMainZuordnungen,
                 "KontenplanUebersicht": verwaltungMainKontenplan,
                 "KontoAnzeigen": verwaltungMainKontenplan,
                 "KontenplanAenderungenTesten": verwaltungMainKontenplan,
                 "KontenplanAenderungenDurchfuehren": verwaltungMainKontenplan,
                 "KontoLoeschenPruefen": verwaltungMainKontenplan,
                 "KontenplanLoeschenDurchfuehren": verwaltungMainKontenplan,
                 "KontenplanNeuerEintragAnfang": verwaltungMainKontenplan,
                 "KontenplanNeuerEintragDurchfuehren": verwaltungMainKontenplan,
                 "NeuesBuchungsjahrTesten": verwaltungMainFibu,
                 "NeuesBuchungsjahrAusfuehren": verwaltungMainFibu,
                 "BaukontoBuchungsformular": verwaltungMainFibu,
                 "BaukontoSpendeBuchen": verwaltungMainFibu,
                 "BaukontoVorlageUebernehmen": verwaltungMainFibu,
                 "BaukontoMonatsbeitragBuchen": verwaltungMainFibu,
                 "BaukontoBuchungTesten": verwaltungMainFibu,
                 "BaukontoBuchungDurchfuehren": verwaltungMainFibu,
                 "LoeschenOhneStorno": verwaltungMainFibu,
                 "BaukontoGesamtliste": verwaltungMainFibu,
                 "BaukontoBuchungAnzeigen": verwaltungMainFibu,
                 "BaukontoVorlageAnzeigen": verwaltungMainFibu,
                 "BaukontoVorlageLoeschen": verwaltungMainFibu,
                 "BaukontoAlsVorlageSpeichern": verwaltungMainFibu,
                 "BaukontoVorlagenGesamtliste": verwaltungMainFibu,
                 "BaukontoStornoPruefen": verwaltungMainFibu,
                 "BaukontoBuchungStornieren": verwaltungMainFibu,
                 #"BaukontoSpendenquittungDirektanzeige": verwaltungMainFibuStatistik,
                 # Achtung, Test: Funktion "umgeleitet":
                 "BaukontoSpendenquittungDirektanzeige": verwaltungMainGemeindekarteiSerienbriefe,
                 "BaukontoSpendenvorlagenAnzeigen": verwaltungMainFibuStatistik,
                 "BaukontoAuswahlSpeichern": verwaltungMainFibuStatistik,
                 "BaukontoSpendenquittungRegistrieren": verwaltungMainFibuStatistik,
                 "BaukontoSpendenquittungFehldruck": verwaltungMainFibuStatistik,
                 "BaukontoSollHabenAlle": verwaltungMainFibuStatistik,
                 "BaukontoSollHabenUnterkonten": verwaltungMainFibuStatistik,
                 "BaukontoSollHabenAlleHauptkonten": verwaltungMainFibuStatistik,
                 "KontoUebersichtAnzeigen": verwaltungMainFibuStatistik,
                 "KontoUebersichtAnzeigenGemeinden": verwaltungMainFibuStatistik,
                 "KontoUebersichtAnzeigenGrundstuecke": verwaltungMainFibuStatistik,
                 "BaukontoBelegnummerReport": verwaltungMainFibuStatistik,
                 "BaukontoEinzelspenderUebersicht": verwaltungMainFibuStatistik,
                 "BaukontoGesamtspendenUebersicht": verwaltungMainFibuStatistik,
                 "BaukontoSpendenquittungenUebersicht": verwaltungMainFibuStatistik,
                 "HauptkontoUebersichtAnzeigen": verwaltungMainFibuStatistik,
                 "GrundstueckeUebersichtAnzeigen": verwaltungMainFibuStatistik,
                 "GemeindekarteiAuswahlSpeichern": verwaltungMainGemeindekarteiSerienbriefe,
                 "GemeindekarteiSerienbriefAnzeigen": verwaltungMainGemeindekarteiSerienbriefe,
                 "GemeindekarteiAuswahlDruckliste": verwaltungMainGemeindekarteiSerienbriefe,
                 "GemeindekarteiSerienbriefDurchfuehren": verwaltungMainGemeindekarteiSerienbriefe,
                 "GemeindekarteiSerienbriefeDrucken": verwaltungMainGemeindekarteiSerienbriefe,
                 "GemeindekarteiSerienbriefDirektanzeige": verwaltungMainGemeindekarteiSerienbriefe,
                 "GemeindekarteiVorlagenAnzeigen": verwaltungMainGemeindekarteiSerienbriefe,
                 "GemeindekarteiVorlageBearbeiten": verwaltungMainGemeindekarteiSerienbriefe,
                 "BaukontoSpendenquittungBearbeiten": verwaltungMainGemeindekarteiSerienbriefe,
                 "GemeindekarteiEmailRundschreibenAnzeigen": verwaltungMainGemeindekarteiSerienbriefe,
                 "GemeindekarteiEmailRundschreibenDurchfuehren": verwaltungMainGemeindekarteiSerienbriefe,
                 "GemeindekarteiReportlabPdf": verwaltungMainGemeindekarteiSerienbriefe,
                 "GemeindekarteiReportlabPdfDurchfuehren": verwaltungMainGemeindekarteiSerienbriefe,
                 "GemeindekarteiVeraenderungen": verwaltungMainGemeindekartei,
                 "GemeindekarteiVeraenderungenDatensaetze": verwaltungMainGemeindekartei,
                 "GemeindekarteiEingabeformular": verwaltungMainGemeindekartei,
                 "GemeindekarteiNeueintragBestaetigung": verwaltungMainGemeindekartei,
                 "GemeindekarteiSuchenDatensatzkurz": verwaltungMainGemeindekartei,
                 "GemeindekarteiNamensliste": verwaltungMainGemeindekartei,
                 "GemeindekarteiUngeprueftListe": verwaltungMainGemeindekartei,
                 "GemeindekarteiDruckliste": verwaltungMainGemeindekartei,
                 "GemeindekarteiAenderungsformular": verwaltungMainGemeindekartei,
                 "GemeindekarteiNeuerEintragPruefen": verwaltungMainGemeindekartei,
                 "GemeindekarteiAenderungenTesten": verwaltungMainGemeindekartei,
                 "GemeindekarteiAenderungenDurchfuehren": verwaltungMainGemeindekartei,
                 "GemeindekarteiLoeschenTesten": verwaltungMainGemeindekartei,
                 "GemeindekarteiLoeschenBestaetigen": verwaltungMainGemeindekartei,
                 "GemeindekarteiLoeschenDurchfuehren": verwaltungMainGemeindekartei,
                 "GemeindekarteiNeuerEintragAnfang": verwaltungMainGemeindekartei,
                 "GemeindekarteiKopierenDurchfuehren": verwaltungMainGemeindekartei,
                 "GemeindekarteiGeburtstagslisteAusgabe": verwaltungMainGemeindekartei,
                 "GemeindekarteiKopierenTesten": verwaltungMainGemeindekartei,
                 "GemeindekarteiGeburtstagslisteAbfrage": verwaltungMainGemeindekartei,
                 "BezirkeAnzeigen": verwaltungMainGemeindekartei,
                 "AllesExportieren": verwaltungMainGemeindekartei,
                 "AllesExportierenDurchfuehren": verwaltungMainGemeindekartei}


# ***** Vorbereitungen: *****************************************
sys.stderr = sys.stdout # zum Debuggen
DatenbankDict = {}
# hier werden die Verbindungen zu verschiedenen Datenbanken gespeichert.
# Die richtige wird aufgerufen durch Auswertung des clientseitigen
# Cookies. Ggf. wird eine neue Verbindung erzeugt. DatenbankDict mu eine globale
# Variable sein, damit die Verbindungen erhalten bleiben.
GeschmacksDict = {}
# hier werden beim ersten Login zu jedem Datenbanknamen die "Geschmacksrichtungen"
# gespeichert wie "metho","evang","kath"...

# *** Einige der folgenden Funktionen sind (z.Zt.?) nicht mehr gebrauchte
# *** "berreste", die aber noch nicht entfernt werden sollen.

def verwaltungMain(MysqlDatenbank=None,Buchungsjahr=None):
    """Die CGI-Haupt-"Schleife". Die Datenbank wird als bereits offene Verbindung bergeben.
    S.dazu die Kommentare in cgiserver_verwaltung.py"""
    global functionsdict, DatenbankDict, einzelplatz, GUI, DEBUG, GeschmacksDict, schaltzentrale
    global datenbank_user,datenbank_passwort,CGI
    formular = cgi.FieldStorage()
    # Da dies als Funktion innerhalb des Servers luft, hat es auch die
    # gleichen Umgebungsvariablen (wie hier mit cgi.FieldStorage() ausgelesen.
    # Achtung allerdings, da der Server einige Umgebungsvariablen mit Default-Werten
    # besetzt (z.B. HTTP_COOKIE). S. cgiserver_verwaltung.py.
    Buchungsjahr = ""
    flag = ""
    steuerflag = 1
    # fr ein paar hliche "Goto"-Sprnge, z.B. beim CSV-Import -
    # gendert: jetzt fr Funktionsaufrufe aus Funktionen heraus
    schluessel = ""
    submitbutton = ""
    cookie = ""
    Datenbank = ""
    Benutzername = ""
    Md5Code = ""
    User = ""    
    formdict = {}
    datumwerkzeug = datumutilities.Datum()
    utilitywerkzeug = verwaltungMainUtilities.verwaltungUtilities() 
    MysqlDatenbank=None
    savestream = sys.stdout
    sys.stdout = streamredirect.Output()
    # Das ist ntig, weil es sonst unter Windows mit dem modifizierten CGIHTTPServer
    # (bisher ungeklrte) Socket-Probleme gibt. Wir sammeln alle Prints
    # in einem Fileobjekt, geben den Inhalt als Variable an den Server zurck,
    # und der(s.dort) gibt den Inhalt "in einem Rutsch" an den Client(Browser).
    # Achtung: aus bisher ungeklrten Grnden funktioniert die eingebaute Klasse
    # StringIO dafr nicht!

    if formular.has_key('Aktion'):
       flag= formular['Aktion'].value
       testversionflag = flag
    if formular.has_key('submitbutton'):
       submitbutton = formular['submitbutton'].value   
    if formular.has_key('schluessel'):
       schluessel=formular['schluessel'].value
      # ggf. URL-Quoting rckgngig!!
    formdict,mzliste = utilitywerkzeug.formulardatenUmwandeln(formular)
    if flag != "DatenbankPasswortSpeichern":
        flag, cookie = utilitywerkzeug.cookiePruefen(flag,"Login","CookieGesetzt",os.environ)
        
    # *************************  <=

    if (datenbank_passwort == "") and (flag != "DatenbankPasswortSpeichern"):
        flag = "DatenbankPasswortEingabe"

    if DEMOVERSION and (DEMO_GESPERRT.has_key(flag)):
        print "Content-type: text/html\n"
        print  """<H3>Diese Aktion funktioniert in der Demo-Version nicht. Benutzen Sie ggf. die "Hilfe"-Funktion, um sich nher zu informieren!</H3>"""
        alleprints = sys.stdout.text
        sys.stdout = savestream
        # alles bekommt wieder seine rechte Ordnung...
        return alleprints
    
    if cookie and flag not in ("DatenbankPasswortEingabe",):
        temp = cookie.split("*")
        if len(temp) == 3:
            Datenbank,Buchungsjahr,User = temp
            if flag not in("Login","VertraulichPruefen"):
               flag = "VertraulichLogin"
        elif len(temp) == 5:
            Datenbank,Buchungsjahr,User,Benutzername,Md5Code = temp
            try:
                if CHECKIN[Datenbank][Benutzername][0] != Md5Code and flag not in("Login","VertraulichPruefen"):
                    flag = "VertraulichLogin"
            except:
                flag = "Login"  # wenn irgendein "verwirrendes" Cookie gespeichert ist.
        if DatenbankDict.has_key(Datenbank):
            MysqlDatenbank = DatenbankDict[Datenbank]        
            # Da es eine solche Verbindung tatschlich gibt,
            # dafr wird beim Login gesorgt. s.u.
        else:
            # Achtung, Test:
            MysqlDatenbank = MySQLdb.connect(db=Datenbank, host="localhost", user=datenbank_user, passwd=datenbank_passwort)
            #flag = "Login"
            # Ein Behelf zum o.g. Problem, vorlufig...
            optionswerkzeug = gemeindeverwaltung.OptionenBearbeiten(MysqlDatenbank,Buchungsjahr)
            geschmacksrichtung = optionswerkzeug.geschmacksrichtung_bestimmen()
            # DatenbankString = "%s" % DatenbankDict[formdict["Datenbank"]]
            GeschmacksDict[Datenbank] = geschmacksrichtung
        gemeindekarteimysql.Benutzername = Benutzername
        baukontomysql.Benutzername = Benutzername
        zuordnungenmysql.Benutzername = Benutzername
        # eine etwas unsaubere Datenbertragung fr das E-Mail-Protokoll und den Bearbeiternamen...
  

    # ***** Aufruf der verschiedenen Prozeduren: ********************

    
    # Achtung, Test - ein Patch:
    User = Benutzername
    # Damit bekommt jeder Benutzername eine eigene UserDir fr die Statusvariablen,
    # und auch im Serienbriefverzeichnis. Es ist auf die entsprechenden Schreibrechte
    # zu achten!

    if (LOKAL_ADMIN.has_key(flag)):
        returnflag = 0
        if Benutzername != NAME_ADMIN or CHECKIN[Datenbank][Benutzername][0] != Md5Code:
            steuerflag = 0
            returnflag = 1
            print "Content-type: text/html\n"
            print """<H3>Sie sind nicht der Administrator - Aktion gesperrt!</H3>"""
       ## if os.environ.get('REMOTE_ADDR',"") not in LOKALE_ADRESSEN:
##            if steuerflag:
##               print "Content-type: text/html\n"
##            returnflag = 1
##            print """<H3>Diese Aktion darf von diesem Rechner aus nicht aufgerufen werden!</H3>"""
        if returnflag:
            alleprints = sys.stdout.text
            sys.stdout = savestream
            # alles bekommt wieder seine rechte Ordnung...
            return alleprints

    if (NUR_WRITE.has_key(flag)) and (CHECKIN[Datenbank][User][2] == "r"):
        print "Content-type: text/html\n"
        print """<H3>Sie haben fr diese Datenbank keine Schreibberechtigung - Aktion gesperrt!</H3>"""
        alleprints = sys.stdout.text
        sys.stdout = savestream
        # alles bekommt wieder seine rechte Ordnung...
        return alleprints

    if (NUR_FIBU.has_key(flag)) and (CHECKIN[Datenbank][User][2] in ("r","w")):
        print "Content-type: text/html\n"
        print """<H3>Sie haben fr diese Datenbank keine Berechtigung zur Buchfhrung - Aktion gesperrt!</H3>"""
        alleprints = sys.stdout.text
        sys.stdout = savestream
        # alles bekommt wieder seine rechte Ordnung...
        return alleprints

    if (MAIL.has_key(flag)) and (CHECKIN[Datenbank][User][3] == "nomail"):
        print "Content-type: text/html\n"
        print """<H3>Sie haben fr diese Datenbank keine EMail-Berechtigung - Aktion gesperrt!</H3>"""
        alleprints = sys.stdout.text
        sys.stdout = savestream
        # alles bekommt wieder seine rechte Ordnung...
        return alleprints                
    
    style = """
<style type="text/css">
body {font-size: 12pt}
tr { font-size: 12pt}
td { font-size: 12pt}
</style>"""
    style = ""
    htmlintro = "Content-type: text/html\n" + style
    # ein Versuch, das Design zentral zu beeinflussen
    if DEBUG:
        print htmlintro
        print "schluessel: %s, Aktion: %s , submitbutton: %s" % (schluessel, flag, submitbutton)
        print "<p>formdict: %s" % formdict
        print "<p>mzliste: %s" % mzliste
        print "<p>Cookie: %s" % cookie
        print "<p>GeschmacksDict: %s<p>" % GeschmacksDict
        print "<p>Umgebung: %s<p>" % os.environ
        statewerkzeug = state.State(User)
        try:
            print "<p>letztes Objekt: %s" % statewerkzeug.variableHolen("letztesObjekt")
        except:
            pass
        try:
            print "<p>letzte Buchungsliste: %s<p>" % statewerkzeug.variableHolen("letzteBuchungsliste")
        except:
            pass

    if funktionsdict.has_key(flag):
        # Achtung, Test:
        #if 1:
        try:
            if DEMOVERSION and ZUSATZSPERRE.has_key(flag):
                if Datenbank in ZUSATZSPERRE[flag]:
                    # Ein knstlicher Abbruch - IOError beliebig gewhlt.
                    raise IOError
            modul = funktionsdict[flag]
            objekt = modul.objekt_holen(einzelplatz,DEBUG=DEBUG,GUI=GUI,formdict=formdict,formular=formular,MysqlDatenbank=MysqlDatenbank,Buchungsjahr=Buchungsjahr,Datenbank=Datenbank,User=User,schluessel=schluessel,submitbutton=submitbutton,steuerflag=steuerflag,cookie=cookie,schaltzentrale=schaltzentrale,datumwerkzeug=datumwerkzeug,utilitywerkzeug=utilitywerkzeug,flag=flag,mzliste=mzliste,htmlintro=htmlintro) 
            getattr(objekt,flag)()
        #else:
        except:
            print htmlintro
            print """<H3>Diese Aktion wird von der Datenbank %s nicht untersttzt.</H3>""" % Datenbank

    if flag == "LoginZeigen":
        print htmlintro 
        print """<H3>Sie arbeiten zur Zeit mit:</H3><p>"""
        if einzelplatz != "ja":
            print "<H3>Datenbank: %s<br>Art der Datenbank: %s<br>Buchungsjahr: %s<br>User: %s</H3>" % (Datenbank,verschiedeneUtilities.geschmacksrichtung(MysqlDatenbank),Buchungsjahr,User)
            # oben fr die Mehrbenutzerversion, ist fr Einzelplatz unntig.
        else:
            print "<H3>Datenbank: %s<br>Art der Datenbank: %s<br>Buchungsjahr: %s</H3>" % (Datenbank,verschiedeneUtilities.geschmacksrichtung(MysqlDatenbank),Buchungsjahr)
        optionswerkzeug = gemeindeverwaltung.OptionenBearbeiten(MysqlDatenbank,Buchungsjahr)
        print "<p><H3>Buchungsjahr abgeschlossen: %s</H3>" % optionswerkzeug.Optionswerte.get("abgeschlossen","")  

    if flag == "LeereSeite":
        print htmlintro
 
    if flag == "CookieGesetzt":
        statewerkzeug = state.StateSystem()
        if einzelplatz != "ja":
            if statewerkzeug.dicteintragPruefen("userdict",formdict["User"]):
                print htmlintro
                print "<H3>Benutzer %s ist schon eingeloggt! Bitte unter anderem Benutzernamen einloggen!</H3>" % formdict["User"]
            # flag = "Login"
        else:
            # *** Warum steht das else hier - geht das Folgende nur fr Einzelplatz? ***
            # Achtung, Test:
            try:
                if not DatenbankDict.has_key(formdict["Datenbank"]):
                    # Verbindung schon vorhanden?
                    if sys.platform[:3] != "win" and einzelplatz == "ja":
                        # auf == "lin" testen geht nicht nmlich nicht mit BSD-Unix!
                        # DatenbankDict[formdict["Datenbank"]] = MySQLdb.connect(db=formdict["Datenbank"], host=os.environ['HOSTNAME'], user = "root") 
                        # TODO: immer als "root" im Netzwerk ein Sicherheitsrisiko?
                        DatenbankDict[formdict["Datenbank"]] = MySQLdb.connect(db=formdict["Datenbank"], host="localhost", user=datenbank_user, passwd=datenbank_passwort) 
                        # TODO: immer als "root" im Netzwerk ein Sicherheitsrisiko?
                    else:
                        # Windows u.a.:
                        DatenbankDict[formdict["Datenbank"]] = MySQLdb.connect(db=formdict["Datenbank"], user = "root")
                # Achtung, Test:
                # zeitstempel = int(time.time())
                optionswerkzeug = gemeindeverwaltung.OptionenBearbeiten(DatenbankDict[formdict["Datenbank"]],formdict["Buchungsjahr"])
                zeitstempel = "einzelplatz"
                if einzelplatz == "ja":
                    # Achtung, Test: alte Cookie-Methode wieder eingefhrt:
                    print "Set-Cookie: name=%s*%s*%s" % (formdict["Datenbank"],formdict["Buchungsjahr"],zeitstempel)
                    # Achtung, hier kann man das Cookie auch auf der Festplatte des Einzelplatz-Benutzers speichern:
                    # statewerkzeugUser = state.State(zeitstempel)
                    # statewerkzeugUser.variableSetzen("Cookie","%s*%s*%s" % (formdict["Datenbank"],formdict["Buchungsjahr"],zeitstempel))
                    formdict["User"] = "%s" % zeitstempel
                    # Fr die Einzelplatzversion werden automatisch Benutzer erzeugt mit dem Unix-Timestamp.
                    # *** Gendert - zu kompliziert! ***
                else:
                    print "Set-Cookie: name=%s*%s*%s" % (formdict["Datenbank"],formdict["Buchungsjahr"],formdict["User"])
                # oben die Mehrbenutzerversion
                # Achtung, Set-Cookie mu in jedem Fall vor Content-type ausgegeben werden, sonst
                # funktioniert es nicht. Der Zeitstempel am Schlu markiert den User zum Wiedererkennen.
                print htmlintro
                # Achtung, Test:
                geschmacksrichtung = optionswerkzeug.geschmacksrichtung_bestimmen()
                # DatenbankString = "%s" % DatenbankDict[formdict["Datenbank"]]
                GeschmacksDict[formdict["Datenbank"]] = geschmacksrichtung
                if einzelplatz != "ja":
                    print """<H3>Login in Datenbank %s, Benutzer %s, Buchungsjahr %s erfolgreich! <br>Art der Datenbank: %s</H3>""" % (formdict["Datenbank"],formdict["User"],formdict["Buchungsjahr"],geschmacksrichtung)
                else:
                    print """<H3>Login in Datenbank %s, Buchungsjahr %s erfolgreich! <br>Art der Datenbank: %s</H3>""" % (formdict["Datenbank"],formdict["Buchungsjahr"],geschmacksrichtung)
                    ##if VERTRAULICH.has_key(formdict["Datenbank"]):
##                        flag = "VertraulichLogin"
##                        steuerflag = 0
                    # Achtung, Test:  immer vertrauliches Login
                    flag = "VertraulichLogin"
                    steuerflag = 0
                    # verschiedeneUtilities.gibLaut("Zug")                
                if optionswerkzeug.Optionswerte.get("abgeschlossen","nein") == "ja":
                    print """<H3>Achtung: Buchungsjahr %s ist abgeschlossen! Sie sollten es nur noch fr statistische Zwecke oder zum Ausdruck von Jahresspendenbescheinigungen nutzen!</H3>""" % formdict["Buchungsjahr"]
                if (formdict["Datenbank"] == "musterkartei" or formdict["Datenbank"] == "musterevang"):
                    print """<br><H3>Achtung, bitte speichern sie in dieser Musterdatenbank keine wichtigen Daten. Erstellen Sie eine Kopie und arbeiten Sie damit!</H3>"""                    
                statewerkzeug.dicteintragSetzen("userdict",formdict["User"],"ja")
            except:
                print htmlintro
                print "<H3>Login in Datenbank %s fehlgeschlagen! Datenbank existiert nicht? Schreibfehler beim Login? Kein Buchungsjahr angegeben?</H3>" % formdict["Datenbank"]

    if flag == "Login":
        print htmlintro 
        if einzelplatz != "ja":
            print """<H4>Mehrplatzversion noch nicht implementiert.</H4>"""
        else:
            import optionen
            # hier Import, sonst hlt der Interpreter (warum?) optionen
            # fr eine lokale Variable.
            # Achtung, Test:
            try:
                dummyoptionswerkzeug = optionen.DummyOptionen()
                listoflists = dummyoptionswerkzeug.gueltigeLogins()
                webarray = optionenweb.OptionenWeb(MysqlDatenbank,schaltzentrale=schaltzentrale)
                print webarray.loginsAnzeigen(listoflists)
                del dummyoptionswerkzeug
            except:
                steuerflag = 0
                flag = "DatenbankPasswortEingabe"
                
    if flag == "DatenbankPasswortEingabe":
        if steuerflag:
            print htmlintro  
        htmlwerkzeug = htmlutilities.HtmlUtilities()      
        print """<H3>Bitte Master-Passwort fr die Datenbanken eingeben: </H3>"""
        print htmlwerkzeug.eingabeFormularAusgeben(('Passwort',),schaltzentrale,hidden=(('Aktion','DatenbankPasswortSpeichern'),),submit='Start',passwortfelder=["Passwort"])

    if flag == "DatenbankPasswortSpeichern":
        print htmlintro
        datenbank_passwort = formdict["Passwort"]
        print """<H3>Master-Passwort wurde eingegeben. Bitte weiter zum "Login".</H3>"""

    if flag == "VertraulichLogin":
        if steuerflag:
            print htmlintro
        htmlwerkzeug = htmlutilities.HtmlUtilities()
        try:
            if formdict["Datenbank"] == "eibenstock_test":
                print """<H3>Dies ist die ffentliche Testversion einer Online-Masterdatenbank fr das Adressbuch der EmK Deutschland. Personen-, Bank- und E-Mail-Daten wurden aus Datenschutzgrnden verfremdet. Benutzername ist "Onkel_Otto", Passwort ist "12345". Berechtigte Bezieher des EmK-Adressbuches knnen auf Anfrage Zugang zum vollen Datenbestand bekommen.</H3>"""
                print """<H3>Nhere Informationen zum Konzept, das auf der Ostdeutschen Jhrlichen Konferenz 2004 in Chemnitz vorgestellt wurde, finden Sie <a href="http://www.bezirksreiter.de/bezirksreiter/emkadressen_zeichnung.pdf">hier</a>.</H3>"""
        except:
            pass
        print """<H3>Dies ist eine geschtzte Datenbank. Haben Sie in Ihrem Browser die "Cookies" aktiviert? Bitte geben Sie Ihren Benutzernamen und Ihr Passwort ein:</H3>"""
        print htmlwerkzeug.eingabeFormularAusgeben(('Benutzername','Passwort'),schaltzentrale,hidden=(('Aktion','VertraulichPruefen'),),submit='Anmelden',passwortfelder=["Passwort"])

    if flag == "VertraulichPruefen":
        code = md5.new(formdict["Benutzername"]+formdict["Passwort"]+CHECKIN_ADD+ "%s" % Datenbank).hexdigest()
        tf = 0
        try:
            if CHECKIN[Datenbank][formdict["Benutzername"]][0] != code:
                print "Set-Cookie: name=%s*%s*%s*%s*%s" % (Datenbank,Buchungsjahr,User,formdict["Benutzername"],code) 
                print htmlintro
                print """<H3>O.k. - Sie haben jetzt Zugriff auf die Datenbank %s.</H3>""" % Datenbank
                tf = 1
                gemeindekartei = gemeindeverwaltung.GemeindekarteiBearbeiten(MysqlDatenbank,Buchungsjahr)
                gemeindekartei.loginProtokoll(formdict["Benutzername"])
        except:
            tf = 1 # Wenn es den Benutzer fr diese Datenbank nicht gibt etc.
        if tf:
            print htmlintro
            print """<H3>Falscher Benutzername und/oder falsches Passwort!</H3>"""
        else:
            print "Set-Cookie: name=%s*%s*%s*%s*%s" % (Datenbank,Buchungsjahr,User,formdict["Benutzername"],code) 
            print htmlintro
            print """<H3>O.k. - Sie haben jetzt Zugriff auf die Datenbank %s.</H3>""" % Datenbank
            gemeindekartei = gemeindeverwaltung.GemeindekarteiBearbeiten(MysqlDatenbank,Buchungsjahr)
            gemeindekartei.loginProtokoll(formdict["Benutzername"])
 
    elif flag == "":
       print "Content-type: text/plain\n"
       print "verwaltungMain.py: Keine/falsche Aktion aufgerufen?!"
       
    alleprints = sys.stdout.text
    sys.stdout = savestream
    # alles bekommt wieder seine rechte Ordnung...
    try:
        if "%s" % sys.version_info[1] != "1":
            MysqlDatenbank.close() # Patch gegen nicht geklrte Probleme "too many connections" bei Python2.2/2.3
            DatenbankDict = {} # Wichtig nach Login in neuer Datenbank
    except:
        pass  
    return alleprints 

if __name__ == "__main__":
    print verwaltungMain()
    # Wenn als normaler CGI-Skript aufgerufen.
    
